{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT Utility; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{***************************************************************************
 *                                                                         *
 *   Author     : Charlie Wiederhold                                       *
 *   Date       : January 7, 1996                                          *
 *   TA         : Gooty                                                    *
 *   TA Section : Wed. 3:00 - 4:00                                         *
 *   Assignment : Program 1 Inventory Tracker - UNIT Utility               *
 *                                                                         *
 ***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


USES
  Crt;                       {* Used for basic screen actions *}

{***************************************************************************}
PROCEDURE Beep
  (Pitch,
   Time : Integer);
  {* Purpose : Creates a sound for error essages to be noticable *}
  {*    Post : Sound has been created                            *}

{***************************************************************************}
PROCEDURE TcTb
  (Tc,
   Tb : byte);
  {* Purpose : Combines the textcolor textbackground commands    *}
  {*    Post : Textcolor and background have been declared       *}

{***************************************************************************}
PROCEDURE WrtC
  (X,
   Y : byte;
   Chr : char);
  {* Purpose : Write a character at designated postion           *}
  {*    Post : Character has been written                        *}

{***************************************************************************}
PROCEDURE WrtS
  (X,
   Y : byte; Str : STRING);
  {* Purpose : Write a string at a designated position           *}
  {*    Post : String has been written                           *}

{***************************************************************************}
PROCEDURE WrtI
  (X,
   Y : byte;
   Int : integer);
  {* Purpose : Write an integer at a designated position         *}
  {*    Post : Integer has been written                          *}

{***************************************************************************}
PROCEDURE WrtR
  (X,
   Y : byte;
   Reel : real;
   Field,
   Decimal : byte);
  {* Purpose : Write a real number at designated postion         *}
  {*    Post : Real has been written with designated fields      *}

{***************************************************************************}
PROCEDURE FrmtI
  (X,
   Y : byte;
   Int : integer;
   Field : byte);
  {* Purpose : Writes an integer at designated positon           *}
  {*    Post : Integer has been written with proper format       *}

{***************************************************************************}
PROCEDURE Clear
  (Text,
   Backcolor,
   Ulx,
   Uly,
   Lrx,
   Lry : byte);
  {* Purpose : Clear a section of screen with designated colors  *}
  {*    Post : Section has been cleared                          *}

{***************************************************************************}
PROCEDURE Hidecursor
  (X,
   Y,
   Color : byte);
  {* Purpose : Hide the cursor at designated postion and color   *}
  {*    Post : Cursor has been hidden                            *}

{***************************************************************************}
PROCEDURE Select
  (Text,
   Background,
   Width,
   Height,
   Startx,
   Starty : byte;
   VAR Cursor : byte);
  {* Purpose : Allows a menu to be used to select options        *}
  {*     Pre : No selection has been made                        *}
  {*    Post : Selection has been made a cursor position         *}

{***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{***************************************************************************}
PROCEDURE Beep
  (Pitch,
   Time : Integer);
  {*    Post : Sound has been created                            *}

BEGIN {* Beep *}
  Sound (Pitch);
  Delay (Time);
  Nosound;
END; {* Beep *}

{***************************************************************************}
PROCEDURE TcTb
  (Tc,
   Tb : byte);
  {*    Post : Textcolor and background have been declared       *}

BEGIN {* TcTb *}
  textcolor (Tc);
  textbackground (Tb);
END; {* TcTb *}

{***************************************************************************}
PROCEDURE WrtC
  (X,
   Y : byte;
   Chr: char);
  {*    Post : Character has been written                        *}

BEGIN {* WrtC *}
  gotoXY (X, Y);
  write (Chr);
END; {* WrtC *}

{***************************************************************************}
PROCEDURE WrtS
  (X,
   Y : byte;
   Str : STRING);
  {*    Post : String has been written                           *}

BEGIN {* WrtS *}
  gotoXY (X, Y);
  write (Str);
END; {* WrtS *}

{***************************************************************************}
PROCEDURE WrtI
  (X,
   Y : byte;
   Int : integer);
  {*    Post : Integer has been written                          *}

BEGIN {* WrtI *}
  gotoXY (x, y);
  write (int);
END; {* WrtI *}

{***************************************************************************}
PROCEDURE WrtR
  (X,
   Y : byte;
   Reel : real;
   Field,
   Decimal : byte);
  {*    Post : Real has been written with designated fields      *}

BEGIN {* WrtR *}
  gotoXY (X, Y);
  write (Reel:Field:Decimal);
END; {* WrtR *}

{***************************************************************************}
PROCEDURE FrmtI
  (X,
   Y : byte;
   Int: integer;
   Field : byte);
  {*    Post : Integer has been written with proper format       *}

BEGIN {* FrmtI *}
  gotoXY (X,Y);
  write (Int:Field);
END; {* FrmtI *}

{***************************************************************************}
PROCEDURE Clear
  (Text,
   Backcolor,
   Ulx,
   Uly,
   Lrx,
   Lry : byte);
  {*    Post : Section has been cleared                          *}

BEGIN {* Clear *}
  TcTb (Text, Backcolor);
  window (Ulx,Uly,Lrx,Lry);
  clrscr;
END; {* Clear *}

{***************************************************************************}
PROCEDURE Hidecursor
  (X,
   Y,
   Color : byte);
  {*    Post : Cursor has been hidden                            *}

Begin {* HideCursor *}
  TcTb (Color, Color);
  WrtC (X, Y, ' ');
  gotoXY (X,Y);
END; {* HideCursor *}

{***************************************************************************}
PROCEDURE Select
  (Text,
   Background,
   Width,
   Height,
   Startx,
   StartY : byte;
   VAR Cursor : byte);
  {*     Pre : No selection has been made                        *}
  {*    Post : Selection has been made a cursor position         *}

VAR
  Choice : char;     {* Key pressed as user's option and choice *}

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{***************************************************************************}
PROCEDURE Move
  (Choice : char;
   VAR Cursor : byte);
  {* Purpose : Move the current position up or down by choice    *}
  {*     Pre : Cursor is at old postion                          *}
  {*    Post : Cursor is at new postion                          *}

BEGIN {* Move *}

  {* Draw over the old arrows *}
  TcTb (Background, Background);
  WrtC (StartX, (Cursor + StartY - 1), ' ');
  WrtC ((StartX + Width + 1), (Cursor + StartY - 1), ' ');

  {* Update postion *}
  CASE Choice OF
    #72 : IF Cursor = 1
            THEN Cursor := Height
            ELSE dec(Cursor);
    #80 : IF Cursor = Height
            THEN Cursor := 1
            ELSE inc(Cursor);
  END; {* CASE *}

  {* Draw new arrows *}
  TcTb (Text, Background);
  WrtC (StartX, (Cursor + StartY - 1), #16);
  WrtC ((StartX + Width + 1), (Cursor + StartY - 1) , #17);

END; {* Move *}

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

BEGIN {* Select *}

  {* Draw starting arrows *}
  TcTb (Text, Background);
  WrtC (StartX, (Cursor + StartY - 1), #16);
  wrtc ((StartX + Width + 1), (Cursor + StartY - 1), #17);
  Hidecursor ((StartX - 1), StartY, Background);
  Choice := readkey;

  {* Read choice and make adjustments *}
  WHILE Choice <> #13 DO
    BEGIN {* WHILE *}
      Move (Choice,Cursor);
      Hidecursor ((StartX - 1), StartY, Background);
      Choice := readkey;
    END; {* WHILE *}

END; {* Select *}

{***************************************************************************}

END. {* Utility *}
