{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT IOServer; {>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}

              {* Most variables identified in Program3.pas *}

{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}

USES
  Prog3Data,   {* Many basic initializations              *}
  Queue2ADT,   {* Contains the QueueADT operations        *}
  CPU;         {* Contains some operations needed for run *}

VAR
  Output : Text;  {* The file to output information to *}

{***************************************************************************}
PROCEDURE IORequest
  (VAR Output : Text;
   VAR CPU : Integer;
   VAR Blocked : QueueType;
       InExecution : QueueElementType);
  {* Purpose : To perform operations on the I/O Server by adding to it    *}
  {*     Pre : New I/O request from program                               *}
  {*    Post : New request has been queued and will be tended to          *}

{***************************************************************************}
PROCEDURE IOFree
  (VAR Output : Text;
   VAR IOChannel : Integer;
   VAR Blocked : QueueType;
   VAR ReadyQueue : ReadyType;
   VAR IOGoing : Boolean;
       IOServiceTime : Integer);
  {* Purpose : To free up the I/O channel and get next program if needed  *}
  {*     Pre : Current I/O operations done                                *}
  {*    Post : If another program queued get it and begin operation       *}

{***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{***************************************************************************}
PROCEDURE IORequest
  (VAR Output : Text;
   VAR CPU : Integer;
   VAR Blocked : QueueType;
       InExecution : QueueElementType);
  {* Purpose : To perform operations on the I/O Server by adding to it    *}
  {*     Pre : New I/O request from program                               *}
  {*    Post : New request has been queued and will be tended to          *}

BEGIN {* IORequest *}

  {* Update values of CPU *}
  InExecution.CPUNeed := InExecution.CPUNeed - 1;
  CPU := 0;

  {* Put it in the I/O Blocked Queue *}
  Enqueue (Blocked, InExecution);
  writeln (Output, ' Program ', InExecution.IDNum,
           ' has made an I/O request');

END; {* IORequest *}

{***************************************************************************}
PROCEDURE IOFree
  (VAR Output : Text;
   VAR IOChannel : Integer;
   VAR Blocked : QueueType;
   VAR ReadyQueue : ReadyType;
   VAR IOGoing : Boolean;
       IOServiceTime : Integer);
  {* Purpose : To free up the I/O channel and get next program if needed  *}
  {*     Pre : Current I/O operations done                                *}
  {*    Post : If another program queued get it and begin operation       *}

VAR
  DoneProgram : QueueElementType; {* Finished I/O program *}

BEGIN {* IOFree *}

  {* Take it from I/O queue and put it in Ready queue *}
  Dequeue (Blocked, DoneProgram);
  Enqueue (ReadyQueue[DoneProgram.Priority], DoneProgram);
  writeln (Output, ' Program ', DoneProgram.IDNum,
           ' has finished I/O request');

  {* Update to get ready for next I/O if needed *}
  IF NOT(EmptyQueue(Blocked)) THEN
      BEGIN {* IF NOT Empty... *}
        IOChannel := IOServiceTime;
        IOGoing := True;
      END {* IF NOT Empty... *}
    ELSE IOGoing := False;

END; {* IOFree *}

{***************************************************************************}

END. {* IOServer *}