                 {* Charlie Wiederhold - Gooty Wed. 3-4 *}
{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT ListData; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


TYPE
  {* The different types of data the variant record BookRecord can have *}
  DataType        = (ListPart, LinkPart);

  {* The relation type for the compare function for the list ADT *}
  RelationType    = (Equal,NotEqual);

  {* Book record for storing the actual information for each book *}
  BookRecord      = RECORD
                      IDNum   : Integer;
                      Title,
                      Authors : STRING[60];
                    END;

  {* Points to the book record for the list info for each tree node *}
  ListPointer     = ^ListElementType;

  {* List record to be used as the main element in the List ADT *}
  ListElementType = RECORD
                      CASE Element : DataType OF
                        ListPart : (BookNode : BookRecord);
                        LinkPart : (ListNode : ListPointer);
                    END;

{***************************************************************************}
FUNCTION Compare
  (Item1,                                   {* First item                  *}
   Item2 : ListElementType) : RelationType; {* Second item                 *}
{* Purpse : To compare objects and return value dependant on their traits  *}
{* Pre    : Relation is unknown for objects                                *}
{* Post   : Relation known and sent back to the main call                  *}

{***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION{>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{***************************************************************************}
FUNCTION Compare
  (Item1,                                   {* First item                  *}
   Item2 : ListElementType) : RelationType; {* Second item                 *}
{* Purpse : To compare objects and return value dependant on their traits  *}
{* Pre    : Relation is unknown for objects                                *}
{* Post   : Relation known and sent back to the main call                  *}

BEGIN {* Compare *}

  IF (Item1.BookNode.IDNum) = (Item2.BookNode.IDNum) THEN
      Compare := Equal
    ELSE Compare := NotEqual;

END; {* Compare *}

{***************************************************************************}

END. {* ListData *}