UNIT ECData;

INTERFACE

USES
  Crt,
  Utility;

CONST
  MainBackColor       = 1;
  TextColor           = 0;
  BackColor           = 7;
  HighlightColor      = 4;
  HeaderColor         = 14;
  SelectColor         = 4;

  DefMaxHealth1       = '100';
  DefMaxHealth2       = '200';
  DefMaxArmor         = '100';
  DefStartArmor       = '0  ';
  DefSteroids         = '400 ';
  DefScuba            = '6400';
  DefHoloDuke         = '2400';
  DefJetpack          = '1600';
  DefBoots            = '200 ';
  DefVision           = '1200';
  DefMedkit           = '100 ';

  DefPistolAmmo       = '200';
  DefShotgunAmmo      = '50 ';
  DefChaingunAmmo     = '200';
  DefRPGAmmo          = '50 ';
  DefPipebombAmmo     = '50 ';

  DefPistolBox        = '12 ';
  DefShotgunBox       = '10 ';
  DefChaingunBox      = '50 ';
  DefRPGBox           = '5  ';
  DefPipebombBox      = '5  ';

  DefRPGRadius        = '1780 ';
  DefPipebombRadius   = '2500 ';

  DefKickStrength     = '10  ';
  DefPistolStrength   = '6   ';
  DefPipebombStrength = '140 ';
  DefRPGStrength      = '140 ';
  DefShotgunStrength  = '10  ';
  DefChaingunStrength = '9   ';

  DefTrooperStrength  = '30  ';
  DefRedTroopStrength = '60  ';
  DefPigCopStrength   = '100 ';
  DefPigCopShield1    = '75  ';
  DefPigCopShield2    = '50  ';
  DefReconStrength    = '50  ';
  DefOctaBStrength    = '175 ';
  DefTurretStrength   = '40  ';
  DefBoss1Strength    = '4500 ';

TYPE

  String3   = STRING[3];
  String4   = STRING[4];
  String5   = STRING[5];
  String8   = STRING[8];

  PlayerR   = RECORD
                MaxHealth1,
                MaxHealth2,
                StartArmor,
                MaxArmor,
                Medkit           : String3;
                Steroids,
                Scuba,
                HoloDuke,
                Jetpack,
                Boots,
                Vision           : String4;
              END;

  AmmoR     = RECORD
                Pistol,
                Shotgun,
                Chaingun,
                RPG,
                Pipebomb         : String3;
              END;

  BoxR      = RECORD
                Pistol,
                Shotgun,
                Chaingun,
                RPG,
                Pipebomb         : String3;
              END;

  StrengthR = RECORD
                Kick,
                Pistol,
                Shotgun,
                Chaingun,
                RPG,
                Pipebomb         : String4
              END;

  RadiusR   = RECORD
                RPG,
                Pipebomb         : String5;
              END;

  EnemyR    = RECORD
                Trooper,
                RedTroop,
                PigCop,
                PigCopShield1,
                PigCopShield2,
                Recon,
                Octabrain,
                Turret           : String4;
                Boss1            : String5;
              END;

  DataR     = RECORD
                Player   : PlayerR;
                Ammo     : AmmoR;
                Box      : BoxR;
                Strength : StrengthR;
                Radius   : RadiusR;
                Enemy    : EnemyR;
              END;

  DataF     = FILE OF DataR;

FUNCTION  Check (Tc, Tb, StartX, StartY : Byte; Prompt : STRING) : Boolean;
PROCEDURE AboutEditCON;
PROCEDURE MainScreenSetup;
PROCEDURE NotAvail;
PROCEDURE UDCChart;

IMPLEMENTATION

{***************************************************************************}
FUNCTION Check (Tc, Tb, StartX, StartY : Byte; Prompt : STRING) : Boolean;

VAR
  Choice : Char;

BEGIN
  MakeWin (Tc,Tb,StartX,StartY,(length(Prompt) + 4),3);
  WrtS (2,1,Prompt);
  HideCursor (1,1,Tb);
  REPEAT
    Choice := Readkey;
  UNTIL (Choice IN ['Y','y','N','n',#13,#27]);
  IF (Choice IN ['Y','y',#13]) THEN
      Check := True
    ELSE Check := False;
END;

{***************************************************************************}
PROCEDURE AboutEditCON;

VAR
  Choice : Char;

BEGIN
  MakeWin (TextColor,BackColor,27,2,35,11);
  TcTb (5,7);
  WrtS (8,1,'EditCON Version 1.1');
  TcTb (4,7);
  WrtS (5,3,'For use with Duke Nukem 3D');
  WrtS (7,4,'Version 1.1 Shareware');
  TcTb (0,7);
  WrtS (5,6,'Author: Charlie Wiederhold');
  WrtS (8,7,'Date: March 10, 1996');
  TcTb (30,0);
  WrtS (5,9,' This program is freeware ');
  HideCursor (1,1,7);
  REPEAT
    Choice := Readkey;
  UNTIL (Choice IN [#13,#27]);
END;

{***************************************************************************}
PROCEDURE MainScreenSetup;

BEGIN
  Clear (HeaderColor,MainBackColor,1,1,80,25);
  MakeWin (TextColor,BackColor,4,2,19,11);
  WrtS (3,1,'Player Info');
  WrtS (3,2,'Weapon Info');
  WrtS (3,3,'Enemy Info');
  WrtS (3,4,'Current Setup');
  WrtS (3,5,'Current Files');
  WrtS (3,6,'Reset Files');
  WrtS (3,7,'UDC Chart');
  WrtS (3,8,'About EditCON');
  WrtS (3,9,'Exit EditCON');
END;

{***************************************************************************}
PROCEDURE NotAvail;

VAR
  Choice : Char;

BEGIN
  MakeWin (TextColor,BackColor,27,2,29,3);
  WrtS (2,1,'This Option Not Available');
  HideCursor (1,1,7);
  REPEAT
    Choice := Readkey;
  UNTIL (Choice IN [#13,#27]);
END;

{***************************************************************************}
PROCEDURE UDCChart;

VAR
  Choice : Char;

BEGIN
  MakeWin (TextColor,BackColor,27,2,50,19);
  writeln (' This is a chart showing what the corresponding');
  writeln (' values are for each item at 100%');
  writeln;
  writeln ('  Steroid Bottle: 200          Trooper: 30');
  writeln ('      Scuba Tank: 3200     Red Trooper: 60');
  writeln ('   Holoduke Pack: 1600         Pig Cop: 100');
  writeln ('    Jetpack Fuel: 600       PC Armor 1: 75');
  writeln ('     Boot Amount: 100       PC Armor 2: 50');
  writeln ('    Night Vision: 1200       Recon Car: 250');
  writeln ('      Kick Power: 10         Octabrain: 175');
  writeln ('    Pistol Power: 6        Gun Turrets: 40');
  writeln ('   Shotgun Power: 10       Ending Boss: 4500');
  writeln ('  Chaingun Power: 9');
  writeln ('       RPG Power: 140');
  writeln ('  Pipebomb Power: 140');
  writeln ('      RPG Radius: 1780');
  write   (' PipeBomb Radius: 2500');
  window (43,2,80,2);
  TcTb (15,7);
  WrtS (1,1,' UDC Value Chart ');
  HideCursor (1,1,7);
  REPEAT
    Choice := Readkey;
  UNTIL (Choice IN [#13,#27]);
END;

{***************************************************************************}

END.