UNIT ResetSave;

INTERFACE

USES
  DOS,
  UserCon1,
  UserCon2,
  Crt,
  ECData,
  Utility;

PROCEDURE SaveFiles        (Player : PlayerR;
                            Ammo : AmmoR;
                            Box : BoxR;
                            Strength : StrengthR;
                            Radius : RadiusR;
                            Enemy : EnemyR);

PROCEDURE GetCurrentValues (VAR Player : PlayerR;
                            VAR Ammo : AmmoR;
                            VAR Box : BoxR;
                            VAR Strength : StrengthR;
                            VAR Radius : RadiusR;
                            VAR Enemy : EnemyR);

PROCEDURE ResetDefaultVals (VAR Player : PlayerR;
                            VAR Ammo : AmmoR;
                            VAR Box : BoxR;
                            VAR Strength : StrengthR;
                            VAR Radius : RadiusR;
                            VAR Enemy : EnemyR);

PROCEDURE PrintCurrentVals (Player : PlayerR;
                            Ammo : AmmoR;
                            Box : BoxR;
                            Strength : StrengthR;
                            Radius : RadiusR;
                            Enemies : EnemyR);
PROCEDURE PrintFileVals;

IMPLEMENTATION

{***************************************************************************}
PROCEDURE SaveFiles (Player : PlayerR;
                     Ammo : AmmoR;
                     Box : BoxR;
                     Strength : StrengthR;
                     Radius : RadiusR;
                     Enemy : EnemyR);

VAR
  Data     : DataR;
  Current  : DataF;
  UserFile : Text;

BEGIN

  assign (UserFile, 'user.con');
  rewrite (UserFile);
  UserPart1 (UserFile);
  UserPart2 (UserFile,Player,Ammo,Box,Strength,Radius,Enemy);
  UserPart3 (UserFile);
  UserPart4 (UserFile);
  UserPart5 (UserFile);
  UserPart6 (UserFile);
  UserPart7 (UserFile);
  UserPart8 (UserFile);
  close (UserFile);

  assign (Current, 'editcon.val');
  rewrite (Current);
  Data.Player := Player;
  Data.Ammo := Ammo;
  Data.Box := Box;
  Data.Strength := Strength;
  Data.Radius := Radius;
  Data.Enemy := Enemy;
  write (Current,Data);
  close (Current);
END;

{***************************************************************************}
PROCEDURE GetCurrentValues (VAR Player : PlayerR;
                            VAR Ammo : AmmoR;
                            VAR Box : BoxR;
                            VAR Strength : StrengthR;
                            VAR Radius : RadiusR;
                            VAR Enemy : EnemyR);

VAR
  Data     : DataR;
  Current  : DataF;

BEGIN
  assign (Current, 'editcon.val');
  reset  (Current);
  read (Current,Data);
  Player := Data.Player;
  Ammo := Data.Ammo;
  Box := Data.Box;
  Strength := Data.Strength;
  Radius := Data.Radius;
  Enemy := Data.Enemy;
  close (Current);
END;

{***************************************************************************}
PROCEDURE ResetDefaultVals (VAR Player : PlayerR;
                            VAR Ammo : AmmoR;
                            VAR Box : BoxR;
                            VAR Strength : StrengthR;
                            VAR Radius : RadiusR;
                            VAR Enemy : EnemyR);

VAR
  Data    : DataR;
  Current : DataF;

BEGIN
  Player.MaxHealth1 := DefMaxHealth1;
  Player.MaxHealth2 := DefMaxHealth2;
  Player.MaxArmor   := DefMaxArmor;
  Player.StartArmor := DefStartArmor;
  Player.Steroids := DefSteroids;
  Player.Scuba := DefScuba;
  Player.Holoduke := DefHoloduke;
  Player.Jetpack := DefJetpack;
  Player.Boots := DefBoots;
  Player.Vision := DefVision;
  Player.Medkit := DefMedkit;

  Ammo.Pistol := DefPistolAmmo;
  Ammo.Shotgun := DefShotgunAmmo;
  Ammo.Chaingun := DefChaingunAmmo;
  Ammo.RPG := DefRPGAmmo;
  Ammo.Pipebomb := DefPipebombAmmo;
  Ammo.Shrinker := DefShrinkerAmmo;
  Ammo.Devastator := DefDevastatorAmmo;
  Ammo.Freezer := DefFreezerAmmo;
  Ammo.Tripbomb := DefTripbombAmmo;

  Box.Pistol := DefPistolBox;
  Box.Shotgun := DefShotgunBox;
  Box.Chaingun := DefChaingunBox;
  Box.RPG := DefRPGBox;
  Box.Pipebomb := DefPipebombBox;
  Box.Shrinker := DefShrinkerBox;
  Box.Devastator := DefDevastatorBox;
  Box.Freezer := DefFreezerBox;

  Radius.RPG := DefRPGRadius;
  Radius.Pipebomb := DefPipebombRadius;
  Radius.Shrinker := DefShrinkerRadius;
  Radius.Tripbomb := DefTripbombRadius;

  Strength.Kick := DefKickStrength;
  Strength.Pistol := DefPistolStrength;
  Strength.Pipebomb := DefPipebombStrength;
  Strength.RPG := DefRPGStrength;
  Strength.Shotgun := DefShotgunStrength;
  Strength.Chaingun := DefChaingunStrength;
  Strength.Shrinker := DefShrinkerStrength;
  Strength.Freezer := DefFreezerStrength;
  Strength.Tripbomb := DefTripbombStrength;

  Enemy.Trooper := DefTrooperStrength;
  Enemy.PigCop := DefPigCopStrength;
  Enemy.PigCopShield1 := DefPigCopShield1;
  Enemy.PigCopShield2 := DefPigCopShield2;
  Enemy.Recon := DefReconStrength;
  Enemy.Octabrain := DefOctaBStrength;
  Enemy.Turret := DefTurretStrength;
  Enemy.RotTurret := DefRTurretStrength;
  Enemy.Lizard := DefLizardStrength;
  Enemy.Drone := DefDroneStrength;
  Enemy.Commander := DefCommandStrength;
  Enemy.Shark := DefSharkStrength;
  Enemy.Boss1 := DefBoss1Strength;
  Enemy.MiniBoss1 := DefMinBoss1Strength;
  Enemy.Boss2 := DefBoss2Strength;
  Enemy.Boss3 := DefBoss3Strength;

  assign (Current, 'editcon.val');
  rewrite (Current);
  Data.Player := Player;
  Data.Ammo := Ammo;
  Data.Box := Box;
  Data.Strength := Strength;
  Data.Radius := Radius;
  Data.Enemy := Enemy;
  write (Current,Data);
  close (Current);

END;

{***************************************************************************}
PROCEDURE PlayerData (Player : PlayerR);

BEGIN
  TcTb (11,0);
  writeln ('       General Settings     ');
  TcTb (0,7);
  writeln;
  writeln ('   Regular Health ==> ', Player.MaxHealth1);
  writeln ('    Atomic Health ==> ', Player.MaxHealth2);
  writeln ('   Starting Armor ==> ', Player.StartArmor);
  writeln ('        Max Armor ==> ', Player.MaxArmor);
  writeln;
  writeln ('   Steroid Bottle ==> ', Player.Steroids);
  writeln ('  Scuba Gear Tank ==> ', Player.Scuba);
  writeln ('  Holoduke Amount ==> ', Player.Holoduke);
  writeln ('     Jetpack Fuel ==> ', Player.Jetpack);
  writeln ('  Boot Time Limit ==> ', Player.Boots);
  writeln ('     Night Vision ==> ', Player.Vision);
  write   ('    Medkit Amount ==> ', Player.Medkit);
END;

{***************************************************************************}

PROCEDURE EnemyData (Enemies : EnemyR);

BEGIN
  TcTb (11,0);
  writeln ('       Enemy Settings       ');
  TcTb (0,7);
  writeln;
  writeln ('          Trooper ==> ', Enemies.Trooper);
  writeln ('          Pig Cop ==> ', Enemies.PigCop);
  writeln ('  Pig Cop Armor 1 ==> ', Enemies.PigCopShield1);
  writeln ('  Pig Cop Armor 2 ==> ', Enemies.PigCopShield2);
  writeln ('        Recon Car ==> ', Enemies.Recon);
  writeln ('        Octabrain ==> ', Enemies.Octabrain);
  writeln ('   Regular Turret ==> ', Enemies.Turret);
  writeln ('  Rotating Turret ==> ', Enemies.RotTurret);
  writeln ('     Sentry Drone ==> ', Enemies.Drone);
  writeln ('  Lizard Enforcer ==> ', Enemies.Lizard);
  writeln ('            Shark ==> ', Enemies.Shark);
  writeln ('    Fat Commander ==> ', Enemies.Commander);
  writeln ('      Mini Boss 1 ==> ', Enemies.MiniBoss1);
  writeln;
  writeln ('   Episode 1 Boss ==> ', Enemies.Boss1);
  writeln ('   Episode 2 Boss ==> ', Enemies.Boss2);
  write   ('   Episode 3 Boss ==> ', Enemies.Boss3);
END;

{***************************************************************************}
PROCEDURE AmmoRadius (Ammo : AmmoR; Radius : RadiusR);

BEGIN
  TcTb (11,0);
  writeln ('      Weapon Settings 1     ');
  TcTb (0,7);
  writeln;
  writeln ('      Pistol Ammo ==> ', Ammo.Pistol);
  writeln ('     Shotgun Ammo ==> ', Ammo.Shotgun);
  writeln ('    Chaingun Ammo ==> ', Ammo.Chaingun);
  writeln ('         RPG Ammo ==> ', Ammo.RPG);
  writeln ('    Pipebomb Ammo ==> ', Ammo.Pipebomb);
  writeln ('    Shrinker Ammo ==> ', Ammo.Shrinker);
  writeln ('  Devastator Ammo ==> ', Ammo.Devastator);
  writeln ('    Tripbomb Ammo ==> ', Ammo.Tripbomb);
  writeln ('     Freezer Ammo ==> ', Ammo.Freezer);
  writeln;
  writeln ('       RPG Radius ==> ', Radius.RPG);
  writeln ('  Pipebomb Radius ==> ', Radius.Pipebomb);
  writeln ('  Shrinker Radius ==> ', Radius.Shrinker);
  write   ('  Tripbomb Radius ==> ', Radius.Tripbomb);
END;

{***************************************************************************}
PROCEDURE BoxPower (Box : BoxR; Strength : StrengthR);

BEGIN
  TcTb (11,0);
  writeln ('      Weapon Settings 2     ');
  TcTb (0,7);
  writeln;
  writeln ('       Pistol Box ==> ', Box.Pistol);
  writeln ('      Shotgun Box ==> ', Box.Shotgun);
  writeln ('     Chaingun Box ==> ', Box.Chaingun);
  writeln ('          RPG Box ==> ', Box.RPG);
  writeln ('     Pipebomb Box ==> ', Box.Pipebomb);
  writeln ('     Shrinker Box ==> ', Box.Shrinker);
  writeln ('   Devastator Box ==> ', Box.Devastator);
  writeln ('      Freezer Box ==> ', Box.Freezer);
  writeln;
  writeln ('    Kicking Power ==> ', Strength.Kick);
  writeln ('     Pistol Power ==> ', Strength.Pistol);
  writeln ('    Shotgun Power ==> ', Strength.Shotgun);
  writeln ('   Chaingun Power ==> ', Strength.Chaingun);
  writeln ('        RPG Power ==> ', Strength.RPG);
  writeln ('   Pipebomb Power ==> ', Strength.Pipebomb);
  writeln ('   Tripbomb Power ==> ', Strength.Tripbomb);
  write   ('    Freezer Power ==> ', Strength.Freezer);
END;

{***************************************************************************}
PROCEDURE PrintCurrentVals (Player : PlayerR;
                            Ammo : AmmoR;
                            Box : BoxR;
                            Strength : StrengthR;
                            Radius : RadiusR;
                            Enemies : EnemyR);

VAR
  Page   : Byte;
  Choice : Char;

BEGIN
  MakeWin (TextColor,BackColor,30,2,31,22,True,True);
  Page := 1;
  choice := #73;
  REPEAT
    IF Choice IN [#73,#81] THEN
      BEGIN
        clrscr;
        CASE Page OF
          1 : PlayerData (Player);
          2 : EnemyData (Enemies);
          3 : AmmoRadius (Ammo,Radius);
          4 : BoxPower (Box,Strength);
        END;
        window (49,23,60,23);
        IF Page = 1 THEN
            BEGIN
              write ('');
              TcTb (15,7);
              write (' PgDn ');
            END;
        IF Page IN [2,3] THEN
            BEGIN
              TcTb (15,7);
              write (' PgUp|PgDn ');
            END;
        IF Page = 4 THEN
            BEGIN
              write ('');
              TcTb (15,7);
              write (' PgUp ');
            END;
        window (31,3,59,22);
        HideCursor (1,1,7);
      END;
    Choice := readkey;
    IF Choice = #0 THEN Choice := readkey;
    CASE Choice OF
      #73 : IF Page > 1 THEN dec(Page);
      #81 : IF Page < 4 THEN inc(Page);
    END;
  UNTIL (Choice IN [#13,#27]);
END;

{***************************************************************************}
PROCEDURE PrintFileVals;

VAR
  Player   : PlayerR;
  Ammo     : AmmoR;
  Box      : BoxR;
  Strength : StrengthR;
  Radius   : RadiusR;
  Enemies  : EnemyR;
  Current  : Text;

BEGIN
  GetCurrentValues (Player,Ammo,Box,Strength,Radius,Enemies);
  PrintCurrentVals (Player,Ammo,Box,Strength,Radius,Enemies);
END;

{***************************************************************************}

END.
