PROGRAM Episoder;

USES
  Crt,
  DOS,
  List2ADT,
  List2Data,
  Utility;

TYPE
  String5        = STRING[5];
  EpisodePart    = RECORD
                     ParTime,
                     RegTime : String5;
                     NewName,
                     MapName : STRING;
                   END;
  Episode1Array  = ARRAY [1..7] OF EpisodePart;
  Episode23Array = ARRAY [1..11] OF EpisodePart;

{***************************************************************************}
PROCEDURE DirectoryWindow (DirList : ListType; VAR NumInWin : Byte);

VAR
  Count     : Byte;
  MapFile   : ListElementType;
  TempChr   : Char;

BEGIN
  MakeWin (7,1,3,11,18,12,True,True);
  TcTb (15,1);
  IF NOT(EmptyList(DirList)) THEN
      BEGIN
        IF ListLength(DirList) >= 10 THEN NumInWin := 10
          ELSE NumInWin := ListLength(DirList);
        FOR Count := 1 TO NumInWin DO
          BEGIN
            MapFile.Position := Count;
            RetrieveElement (DirList,MapFile);
            WrtS (2,Count,MapFile.FileName);
          END;
      END
    ELSE
      BEGIN
        WrtS (2,1,'No .MAPs Found');
        WrtS (2,2,'Press <ENTER>');
        HideCursor (1,1,1);
        REPEAT
          TempChr := readkey
        UNTIL TempChr = #13;
      END;
END;

{***************************************************************************}
PROCEDURE DirSelect
  (RegText, RegBack, SelText, SelBack, Startx, StartY, Height : Byte;
   VAR Cursor    : Byte;
   DirList       : ListType);

VAR
  Choice  : Char;
  Top     : Integer;
  MapFile : ListElementType;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE Move
  (Choice     : Char;
   VAR Cursor : Byte);

VAR
  Count : Byte;

BEGIN
  CASE Choice OF
    #72 : IF Cursor > 1 THEN dec(Cursor)
            ELSE IF (Top + Cursor - 1) > 1 THEN dec(Top);
    #80 : IF Cursor < Height THEN inc(Cursor)
            ELSE IF (Top + Cursor - 1) < ListLength(DirList) THEN inc(Top);
    #71 : BEGIN
            Cursor := 1;
            Top := 1;
          END;
    #79 : BEGIN
            Cursor := Height;
            Top := (ListLength(DirList) - Height + 1);
          END;
  END;
  TcTb (RegText, RegBack);
  FOR Count := 1 TO Height DO
    BEGIN
      MapFile.Position := (Count + Top - 1);
      RetrieveElement (DirList,MapFile);
      WrtS (StartX,Count,MapFile.FileName);
    END;
  TcTb (SelText, SelBack);
  MapFile.Position := Cursor + Top - 1;
  RetrieveElement (DirList,MapFile);
  WrtS (StartX, (Cursor + StartY - 1), MapFile.FileName);
END;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

BEGIN
  TcTb (SelText, SelBack);
  Top := Cursor;
  MapFile.Position := Cursor;
  RetrieveElement (DirList,MapFile);
  WrtS (StartX, (Cursor + StartY - 1), MapFile.FileName);
  Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
  Choice := readkey;
  WHILE NOT(Choice IN [#13,#27]) DO
    BEGIN
      IF Choice IN [#72,#80,#71,#79,#73,#81] THEN Move (Choice,Cursor);
      Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
      Choice := readkey;
    END;
  IF Choice = #13 THEN Cursor := 1
    ELSE Cursor := 2;
END;

{***************************************************************************}
PROCEDURE GetDirectory (VAR DirList : ListType);

VAR
  DirInfo  : SearchRec;
  NumFiles,
  Count    : Byte;
  MapFile  : ListElementType;

BEGIN
  FindFirst('*.map',Archive,DirInfo);
  NumFiles := 0;
  WHILE (DosError = 0) AND (NumFiles < 255) DO
    BEGIN
      inc(NumFiles);
      MapFile.FileName := ' ' + DirInfo.Name;
      FOR Count := length(MapFile.FileName) TO 13 DO
        MapFile.FileName := MapFile.FileName + ' ';
      InsertElement (DirList,MapFile);
      FindNext(DirInfo);
    END;

  ResetList (DirList);
  FOR Count := 1 TO NumFiles DO
    BEGIN
      GetNextItem (DirList,MapFile);
      DeleteElement (DirList,MapFile);
      MapFile.Position := Count;
      InsertElement (DirList,MapFile);
    END;
END;

{***************************************************************************}
PROCEDURE Initialize
  (VAR Menu      : MenuType;
   VAR Exit      : Boolean;
   VAR Cursor    : Byte);

VAR
  Count : 1..10;

BEGIN
  Menu[1] := ' L.A. Meltdown ';
  Menu[2] := ' Lunar Apocalypse ';
  Menu[3] := ' Shrapnel City ';
  Menu[4] := ' Exit Episoder ';
  Exit := False;
  Cursor := 1;
END;

{***************************************************************************}
PROCEDURE MainScreenSetup
  (Menu : MenuType);

VAR
  Count : Byte;

BEGIN
  Clear (0,7,1,1,80,1);
  WrtS (2,1,'Episoder by Charlie Wiederhold');
  WrtS (53,1,'(c) 1996 Charlie Wiederhold');
  Window (1,2,80,25);
  TcTb (8,0);
  FOR Count := 2 TO 24 DO
    WrtS (1,Count,'');
  TcTb (10,0);
  WrtS (74,23,'ver 0.1');
  Clear (0,7,1,25,80,25);
  WrtS (5,1,'Visit the WiederWeb RTS Archive: http://ccwf.cc.utexas.edu/~wieder/ROTT/');
  TcTb (5,7);
  WrtC (3,1,#9);
  WrtC (78,1,#9);
  MakeWin (7,1,3,3,22,6,True,True);
  TcTb (15,1);
  FOR Count := 1 TO 4 DO
    WrtS (2,Count,Menu[Count]);
END;

{***************************************************************************}
PROCEDURE LAMeltdown (VAR Episode1 : Episode1Array);

VAR
  Cursor,
  NumInWin : Byte;
  DirList  : ListType;

BEGIN
  CreateList (DirList);
  GetDirectory (DirList);
  DirectoryWindow (DirList,NumInWin);
  Cursor := 1;
  DirSelect (15,1,0,7,2,1,NumInWin,Cursor,DirList);
  DestroyList (DirList);
END;

{***************************************************************************}
PROCEDURE LunarApocalypse (VAR Episode2 : Episode23Array);

VAR
  NumFiles : Byte;
  DirList : ListType;

BEGIN
END;

{***************************************************************************}
PROCEDURE ShrapnelCity (VAR Episode3 : Episode23Array);

VAR
  NumFiles : Byte;
  DirList : ListType;

BEGIN
END;

{***************************************************************************}
PROCEDURE ControlProcessing;

VAR
  Cursor      : Byte;
  Menu        : MenuType;
  Exit        : Boolean;
  Episode1 : Episode1Array;
  Episode2,
  Episode3 : Episode23Array;

BEGIN
  Initialize (Menu,Exit,Cursor);
  REPEAT
    MainScreenSetup (Menu);
    Select (15,1,0,7,2,1,4,Cursor,Menu);
    CASE Cursor OF
      1 : LAMeltdown (Episode1);
      2 : LunarApocalypse (Episode2);
      3 : ShrapnelCity (Episode3);
      4 : Exit := TRUE;
    END;
  UNTIL Exit;
END;

{***************************************************************************}

BEGIN
  checkbreak := False;
  ControlProcessing;
  clear (7,0,1,1,80,25);
  writeln ('Thanks for using Episoder by Charlie Wiederhold.');
  writeln ('WiederWeb RTS Archive: http://ccwf.cc.utexas.edu/~wieder/ROTT/');
END.