UNIT ImgData;

INTERFACE

USES
  DOS,
  NewDelay,
  Crt,
  Utility,
  GrubData;

CONST
  ImageExtention = '.img';

TYPE
  PixelType  = RECORD
                 Character : Char;
                 Color     : Byte;
               END;
  ScreenType = ARRAY [1..64,1..40] OF PixelType;

PROCEDURE DrawPixel (Pixel : PixelType; XCoord, YCoord : Byte);
PROCEDURE DrawImage (ImageFileName : FileName; StartX, StartY : Byte);
PROCEDURE DrawScreen (Screen : ScreenType; StartX, StartY : Byte);

IMPLEMENTATION

{****************************************************************************}
PROCEDURE DrawPixel (Pixel : PixelType; XCoord, YCoord : Byte);

VAR
  Offset : Integer;

BEGIN
  Offset := ((XCoord - 1) * 2) + ((YCoord - 1) * 160);
  mem[$B800:Offset] := ord(Pixel.Character);
  mem[$B800:Offset + 1] := Pixel.Color;
END;

{****************************************************************************}
PROCEDURE DrawImage (ImageFileName : FileName; StartX, StartY : Byte);

VAR
  Root       : FileName;
  Pixel      : PixelType;
  Count,
  Counter,
  Width,
  Height     : Byte;
  Image      : FILE;
  NumRead    : Integer;

BEGIN
  Root := GetRoot;
  NumRead := 0;
  assign (Image,Root + '\images\' + ImageFileName + ImageExtention);
  reset (Image,1);
  blockread (Image, Width, sizeof(Width), NumRead);
  blockread (Image, Height, sizeof(Height), NumRead);
  FOR Count := 1 TO Height DO
    FOR Counter := 1 TO Width DO
      BEGIN
        blockread (Image, Pixel, sizeof(Pixel), NumRead);
        DrawPixel (Pixel,StartX + Counter - 1, StartY + Count - 1);
      END;
  close (Image);
END;

{****************************************************************************}
PROCEDURE DrawScreen (Screen : ScreenType; StartX, StartY : Byte);

VAR
  Root       : FileName;
  Pixel      : PixelType;
  Count,
  Counter,
  Width,
  Height     : Byte;
  Image      : FILE;
  NumRead    : Integer;

BEGIN
  FOR Count := 1 TO 40 DO
    FOR Counter := 1 TO 64 DO
      DrawPixel (Screen[Counter,Count],StartX + Counter - 1, StartY + Count - 1);
END;

{****************************************************************************}

END.