PROGRAM LayoutViewer;

USES
  NewDelay,
  Crt,
  Dos,
  Menus,
  Utility,
  SndData,
  GrubData;

CONST
  MainW       = 64;
  MainH       = 40;
  StatW       = 16;
  StatH       = 40;
  TextW       = 80;
  TextH       = 8;

VAR
  OrigMode    : Integer;
  MainWinPos,
  StatWinPos,
  TextWinPos  : WinPosType;
  Layout     : FILE;
  NumRead    : Integer;
  Root       : FileName;

BEGIN
  Root := GetRoot;

  OrigMode := LastMode;
  TextMode (C80 + Font8x8);
  HighIntensity;
  CursorOff;

  NumRead := 0;
  assign (Layout, Root + '\layout.grb');
  reset (Layout,1);
  blockread (Layout, MainWinPos, sizeof(MainWinPos), NumRead);
  blockread (Layout, StatWinPos, sizeof(StatWinPos), NumRead);
  blockread (Layout, TextWinPos, sizeof(TextWinPos), NumRead);
  close (Layout);

  WITH StatWinPos DO MakeWin (Text,Back,StartX,StartY,StatW,StatH,Border,Shadow);
  WrtS (1,1,'Stat Window');
  WrtS (1,2,'1234567890123456');
  WITH TextWinPos DO MakeWin (Text,Back,StartX,StartY,TextW,TextH,Border,Shadow);
  WrtS (1,1,'Text Window');
  WrtS (1,2,'12345678901234567890123456789012345678901234567890123456789012345678901234567890');
  WITH MainWinPos DO MakeWin (Text,Back,StartX,StartY,MainW,MainH,Border,Shadow);
  WrtS (1,1,'Main Window');
  WrtS (1,2,'1234567890123456789012345678901234567890123456789012345678901234');
  REPEAT UNTIL KeyPressed;
  CursorOn;
  TextMode (OrigMode);

END.
