PROGRAM Gambler;

{*****************************************************************************}
{*                                                                           *}
{*   Author     : Charlie Wiederhold                      *}
{*   Date       : September 24, 1995                                         *}
{*   Assignment : Supplemental Problem #6                                    *}
{*   Purpose    : To read from the user, a gamblers chances of winning and   *}
{*                the payoff for winning in a simulation of 1000 evenings of *}
{*                games.  The gambler will begin every night with $20, and   *}
{*                will continue until his balance is $0 or $50. This will    *}
{*                continue for 1000 evenings, and the number of winning and  *}
{*                losing evenings will be calculated and printed at the      *}
{*                conclusion of the program.                                 *}
{*                                                                           *}
{*****************************************************************************}

USES
  Crt;

CONST
  Bet      = 2;                {* Gambler bet for each game *}
  Evenings = 1000;             {* Number of evenings the simulation runs *}
  LoseOver = 0;                {* Amount gambler needs to lose evening *}
  Start    = 20;               {* Gambler starting balance *}
  WinOver  = 40;               {* Amount gembler needs to win evening *}

VAR
  ProbabilityA,                {* Chances of winning... *}
  ProbabilityB,                {* ...out of total chances *}
  Payoff,                      {* Amount payed off to player for winning *}
  Wins,                        {* Number of wins gambler has *}
  Losses,                      {* Number of losses gambler has *}
  Played,                      {* Number of games played *}
  Result,                      {* Result of random win generation *}
  CurrentWinnings : integer;   {* Current balance of gamblers *}



BEGIN  {* Program Gambler *}

  clrscr;

  {* Get random seed for random function *}
  randomize;

  {* Get probability of winning from user *}
  writeln ('Enter probability of winning in form a/b.  (Ex. 1/2 = 50%)');
  write ('Enter a ==> ');
  readln (ProbabilityA);
  write ('Enter b ==> ');
  readln (ProbabilityB);
  writeln;

  {* Get payoff for games from user *}
  write ('Enter the payoff for each game ==> ');
  readln (Payoff);

  {* Initializes wins and losses *}
  Wins := 0;
  Losses := 0;

  {* Loop that simulates all evening games *}
  FOR Played := 1 TO Evenings DO

    BEGIN {* For Loop *}

      {* Initializes Winnings to $20 every night *}
      CurrentWinnings := Start;

      {* Loop that simulates one evening of games *}
      REPEAT

        {* Random number to determine winning or losing *}
        Result := random(ProbabilityB) + 1;

        {* Tests to see of gambler won *}
        IF Result <= ProbabilityA
          THEN CurrentWinnings := CurrentWinnings + Payoff
          ELSE CurrentWinnings := CurrentWinnings - Bet;

      UNTIL (CurrentWinnings >= WinOver) or (CurrentWinnings <= LoseOver);

      {* Calculates number of wins and losses *}
      IF CurrentWinnings >= WinOver
        THEN inc(Wins)
        ELSE inc(Losses);

    END; {* For Loop *}

  {* Outputs the wins and losses for the 1000 evenings *}
  writeln;
  writeln;
  writeln ('Tabulation of winning and losing evenings');
  writeln ('-----------------------------------------');
  writeln ('Winning evenings ==> ', wins);
  writeln ('Losing evenings  ==> ', losses);

  {* Hold output on screen *}
  readln;

END.  {* Program Gambler *}
