Program TestQuick;

USES Crt;

CONST
  ArraySize = 7000;

TYPE
  ArrayRange = 1..ArraySize;
  ArrayData = ARRAY [ArrayRange] OF integer;

VAR
  Counting : Real;

PROCEDURE Swap (VAR First, Second : integer);

VAR
  Temp : integer;

BEGIN
  Temp := First;
  First := Second;
  Second := Temp;
END;

PROCEDURE QuickSort (VAR Data : ArrayData; Low, High : ArrayRange);

VAR
  LowerCheck,
  UpperCheck : integer;

BEGIN
  LowerCheck := low + 1;
  UpperCheck := high;

  REPEAT
    Counting := Counting + 1;
    WHILE (LowerCheck <= UpperCheck) AND (Data[UpperCheck] >= Data[Low]) DO
      UpperCheck := UpperCheck - 1;

    WHILE (LowerCheck < UpperCheck) AND (Data[LowerCheck] <= Data[Low]) DO
      LowerCheck := LowerCheck + 1;

    IF LowerCheck < UpperCheck
      THEN Swap (Data[LowerCheck],Data[UpperCheck]);

  UNTIL UpperCheck <= LowerCheck;

  Swap (Data[Low],Data[UpperCheck]);

  IF Low < UpperCheck - 1
    THEN QuickSort (Data,Low,UpperCheck - 1);
  IF UpperCheck + 1 < High
    THEN QuickSort (Data,UpperCheck + 1, High);
END;

PROCEDURE CharlieSort (VAR Data : ArrayData);

VAR
  Count,
  Counter : ArrayRange;

BEGIN
  FOR Count := 1 TO ArraySize DO
    FOR Counter := 1 TO ArraySize - 1 DO
      IF Data[Counter] > Data[Counter + 1]
        THEN Swap (Data[Counter],Data[Counter + 1]);
END;

PROCEDURE ControlProcessing;

VAR
  Data  : ArrayData;
  Count : ArrayRange;

BEGIN
  clrscr;
  writeln ('This compares the QuickSort and the "Charlie"Sort.');
  writeln;

  FOR Count := 1 TO ArraySize DO
    Data[Count] := random(255) + 1;
  write ('Now time to sort the array using QuickSort.');
  readln;
  write ('Sorting...');
  counting := 0;
  QuickSort (Data,1,ArraySize);
  writeln;
  writeln ('Done QuickSorting with ', counting:0:0, ' passes');
  readln;

  FOR Count := 1 TO ArraySize DO
    Data[Count] := random(255) + 1;
  write ('Now time to sort the array using "Charlie"Sort.');
  readln;
  write ('Sorting...');
  counting := 0;
  CharlieSort (Data);
  writeln;
  writeln ('Done "Charlie"Sorting with ', counting:0:0, ' passes.');
  readln;

END;

BEGIN
  Randomize;
  ControlProcessing;
END.


