UNIT RemindData;

INTERFACE

USES
  Crt,
  Dos,
  Utility;

CONST
  DateBack   = 3;
  DateText   = 14;

  MainBack   = 1;
  MainText   = 15;

  MenuBack   = 7;
  MenuText   = 0;

  SelecBack  = 0;
  SelecText  = 15;

  Title1Back = 5;
  Title1Text = 12;
  Title2Back = 0;
  Title2Text = 10;

TYPE
  YearType  = 1991..2090;
  MonthType = STRING[8];
  DaysType  = 1..31;
  DoWType   = STRING[9];

  DayType   = RECORD
                Year  : YearType;
                Month : MonthType;
                Date  : DaysType;
                DoW   : DoWType;
              END;

  DateType  = RECORD
                Year,
                Month,
                Date,
                DoW   : Word;
              END;

{***************************************************************************}
PROCEDURE MainScreen (Menu : MenuType; VAR Today : DayType; VAR Todate : DateType);
{***************************************************************************}
PROCEDURE RetrieveDate (VAR Today : DayType; VAR Todate : DateType);
{***************************************************************************}

IMPLEMENTATION

{***************************************************************************}
PROCEDURE RetrieveDate (VAR Today : DayType; VAR Todate : DateType);

BEGIN
  WITH Todate DO
    BEGIN
      getdate (Year,Month,Date,DoW);
      Today.Year := Year;
      CASE Month OF
         1 : Today.Month := 'January';
         2 : Today.Month := 'February';
         3 : Today.Month := 'March';
         4 : Today.Month := 'April';
         5 : Today.Month := 'May';
         6 : Today.Month := 'June';
         7 : Today.Month := 'July';
         8 : Today.Month := 'August';
         9 : Today.Month := 'September';
        10 : Today.Month := 'October';
        11 : Today.Month := 'November';
        12 : Today.Month := 'December';
      END;
      Today.Date := Date;
      CASE DoW OF
        0 : Today.DoW := 'Sunday';
        1 : Today.DoW := 'Monday';
        2 : Today.DoW := 'Tuesday';
        3 : Today.DoW := 'Wednesday';
        4 : Today.DoW := 'Thursday';
        5 : Today.DoW := 'Friday';
        6 : Today.DoW := 'Saturday';
      END;
    END;
END;

{***************************************************************************}
PROCEDURE MainScreen (Menu : MenuType; VAR Today : DayType; VAR Todate : DateType);

VAR
  Count : 1..MaxMenu;

BEGIN
  MakeWin (MainText,MainBack,17,1,64,24,False,False);

  MakeWin (DateText,DateBack,17,25,64,1,False,False);
  RetrieveDate (Today,Todate);
  GotoXY (10,1);
  WITH Today DO
    write (' Current Date: ', DoW, ' - ', Month, ' ', Date, ', ', Year);

  MakeWin (MenuText,MenuBack,1,1,16,25,False,False);

  TcTb (Title1Text,Title1Back);
  WrtS (2,2, '    ');
  WrtS (2,3, '            ');
  WrtS (2,4, '    ');
  WrtS (2,5, '    ');
  TcTb (Title2Text,Title2Back);
  WrtS (2,6, '  SIGMA SOFT  ');

  TcTb (MenuText,MenuBack);
  FOR Count := 1 TO MaxMenu DO
    WrtS (2,Count + 9,Menu[Count]);

  TcTb (Title1Text,Title1Back);
  WrtS (2,19,'    ');
  WrtS (2,20,'           ');
  WrtS (2,21,'        ');
  WrtS (2,22,'    ');
  TcTb (Title2Text,Title2Back);
  WrtS (2,23,'  S  O  F  T  ');

END;

{***************************************************************************}

END.