Program CHECKBOOK (user_file);

uses crt, wieder;

type
  amount_array  = array [1..25] of real;
  num_array     = array [1..25] of integer;
  string_array  = array [1..25] of string;
  user_record   = record
                    balance  : real;
                    checks   : amount_array;
                    checknum : num_array;
                    chkdate  : string_array;
                    chkpurp  : string_array;
                    currentc : integer;
                    deposits : amount_array;
                    dpstnum  : num_array;
                    dpstdate : string_array;
                    currentd : integer;
                  end;

var
  user_file : file of user_record;
  user      : user_record;
  selec     : byte;

{*****************************************************************************}
Procedure SAVE;

Begin
  assign (user_file, 'c:chkbook.dat');
  rewrite (user_file);
  write (user_file, user);
  close (user_file);
End;

{*****************************************************************************}
Procedure LOAD;

Begin
  assign (user_file, 'c:chkbook.dat');
  reset (user_file);
  read (user_file, user);
  close (user_file);
End;

{*****************************************************************************}
Procedure UPDATEACCOUNT (check, deposit : real);

Begin
  user.balance := user.balance + deposit - check;
End;

{*****************************************************************************}
Procedure VIEWCHECKS;

var
  count : byte;

Begin
  clrscr;
  for count := 1 to user.currentc do
    begin
      tctb (11,1);
      write ('Number: ');
      tctb (15,1);
      write (user.checknum[count]:4);
      tctb (11,1);
      write ('Amount: $ ':13);
      tctb (15,1);
      write (user.checks[count]:6:2);
      tctb (11,1);
      write ('Date: ':10);
      tctb (15,1);
      write (user.chkdate[count]:8);
      tctb (11,1);
      write ('Purpose: ':12);
      tctb (15,1);
      if count < 25
        then writeln (user.chkpurp[count])
        else write (user.chkpurp[count]);
    end;
  readln;
End;

{*****************************************************************************}
Procedure VIEWDEPOSITS;

var
  count : byte;

Begin
  clrscr;
  for count := 1 to user.currentd do
    begin
      tctb (11,1);
      write ('Number: ');
      tctb (15,1);
      write (user.dpstnum[count]:4);
      tctb (11,1);
      write ('Amount: $ ':13);
      tctb (15,1);
      write (user.deposits[count]:6:2);
      tctb (11,1);
      write ('Date: ':10);
      tctb (15,1);
      if count < 25
        then writeln (user.dpstdate[count]:8)
        else write (user.dpstdate[count]:8);
    end;
  readln;
End;

{*****************************************************************************}
Procedure GETCHECK;

Begin
  clrscr;
  inc(user.currentc);
  write ('Enter date ==> ');
  readln (user.chkdate[user.currentc]);
  write ('Enter check number ==> ');
  readln (user.checknum[user.currentc]);
  write ('Enter the amount ==> $');
  readln (user.checks[user.currentc]);
  write ('Enter the purpose ==> ');
  readln (user.chkpurp[user.currentc]);
  UPDATEACCOUNT (user.checks[user.currentc],0);
  SAVE;
End;

{*****************************************************************************}
Procedure GETDEPOSIT;

Begin
  clrscr;
  inc(user.currentd);
  write ('Enter date ==> ');
  readln (user.dpstdate[user.currentd]);
  write ('Enter deposit number ==> ');
  readln (user.dpstnum[user.currentd]);
  write ('Enter the amount ==> $');
  readln (user.deposits[user.currentd]);
  UPDATEACCOUNT (0,user.deposits[user.currentd]);
  SAVE;
End;

{*****************************************************************************}
Procedure RESETSTATUS;

var
  count : byte;

Begin
  user.currentc := 0;
  user.currentd := 0;
  for count := 1 to 25 do
    begin
      user.checks[count] := 0;
      user.checknum[count] := 0;
      user.chkdate[count] := '';
      user.chkpurp[count] := '';
      user.deposits[count] := 0;
      user.dpstnum[count] := 0;
      user.dpstdate[count] := '';
    end;
  SAVE;
End;

{*****************************************************************************}
Procedure DOWHAT;

Begin
  tctb (15,1);
  clrscr;
  writeln;
  writeln (' Current checks.......... ', user.currentc);
  writeln (' Current deposits........ ', user.currentd);
  writeln (' Current balance......... $', user.balance:6:2);
  writeln;
  writeln;
  writeln (' 0: Exit');
  writeln (' 1: Enter checks');
  writeln (' 2: Enter deposits');
  writeln (' 3: View checks');
  writeln (' 4: View deposits');
  writeln (' 5: Reset check and deposit status');
  writeln;
  write (' Select an option ==> ');
  readln (selec);
  case selec of
    1 : GETCHECK;
    2 : GETDEPOSIT;
    3 : VIEWCHECKS;
    4 : VIEWDEPOSITS;
    5 : RESETSTATUS;
  end;
End;

{*****************************************************************************}

Begin
  LOAD;
  repeat
    DOWHAT;
  until selec = 0;
  SAVE;
End.