program frac;

{****************************************************************************
 *   Author  : Charlie Wiederhold                                           *
 *   Date    : 01/10/94                                                     *
 *   Purpose : This program is designed to add, subtract, multiply, and     *
 *             divide fractions with single digit positive numerators and   *
 *             denominators.  Then it outputs the equation again in a       *
 *             different form and reduces the answer to its lowest form.    *
 *             A special command <e x I t T> is used to exit the program    *
 *             when the equation is asked for.                              *
 *   Method  : Write statements promt the user to enter the equation in     *
 *             this form <a/c (operator) b/d> and read statements read the  *
 *             values one at a time and convert them into an ordinal value. *
 *             From here the numerator and denominator are calculated       *
 *             depending upon the operator specified.  Then the answer is   *
 *             simplified into its lowest possible form.                    *
 *                                                                          *
 *   Structure : This program consits of the following modules.             *
 *                 Those in lowercase letters are utilities                 *
 *                 Those in uper and lowercase letters are plain modules    *
 *                 The all caps one is the main running module              *
 *                      writeati   : allows the gotoXY statement and        *
 *                                   the write statement to be combined     *
 *                                   to write an integer at a certain       *
 *                                   position on the screen                 *
 *                      writeatc   : same as writeati except it writes      *
 *                                   a char variable                        *
 *                      hide       : hides the cursor from the screen       *
 *                      quit       : program run control procedure          *
 *                      Writefrac  : writes out the inputed fractions       *
 *                                   in a different form then was inputed   *
 *                      Writeans   : writes the answer to the equation      *
 *                                   in simplified form                     *
 *                      Simplify   : simplifies the answer to the equation  *
 *                      Case_state : where the program decides what steps   *
 *                                   of calculation to take depending       *
 *                                   upon the operator entered              *
 *                      RUN        : integrates all other procedures into   *
 *                                   one so the main program contains only  *
 *                                   one command                            *
 *                      <Main program>                                      *
 ****************************************************************************}

uses crt;  { if you don't know what this is, go back home to MOMMY! }

var
  a,                  { char value of the first numerator }
  b,                  { char value of the second numerator }
  c,                  { char value of the first denomenator }
  d,                  { char value of the second denomenator }
  oper,               { operator the person chooses to use }
  nada    : char;     { value assigned to extra read statements }
  j,                  { output control variable }
  ai,                 { integer value of the first numerator }
  bi,                 { integer value of the second numerator }
  ci,                 { integer value of the first denomenator }
  di,                 { integer value of the second denomenator }
  num,                { used to find the greatest factor from numerator }
  den,                { used to find the greatest factor from denomenator }
  gcf1,               { greatest common factor check one }
  gcf2,               { greatest common factor ckeck two }
  newnum,             { numerator of the answer }
  newden  : integer;  { denomenator of the answer }
  done    : boolean;  { cheks to see if passcode is entered }

{****************************************************************************}

procedure writeati (x,y, int : integer);

{ simplifies these two statements into one }
begin  { writeati }

  gotoXY (x,y);
  write (int);

end;  { writeati }

{****************************************************************************}

procedure writeatc (x,y : integer; chr : char);

{ simplifies these two statements into one }
begin  { writeatc }

  gotoXY (x,y);
  write (chr);

end;  { writeatc }

{****************************************************************************}

procedure hide;

{ hides the cursor from the screen }
begin  { hide }

  textcolor (7);
  textbackground (7);
  writeatc (1,1,' ');
  gotoXY (1,1);

end;  { hide }

{****************************************************************************}

procedure quit;

{ allows the user to enter a password to quit the program }
{ e x I t T  is the password }
begin  { quit }

  { checks to make sure password has been entered }
  if (a = 'e') and (c = 'x') and (oper = 'I') and (b = 't') and (d = 'T')
    then
      begin { then }
        done := true;
        hide;
        delay (800);
      end  { then }

    { if incorrectly punched then the program continues }
    else
      done := false;

end;  { quit }

{****************************************************************************}

procedure Writefrac;

{ writes out the inputed fractions verticaly }
Begin  { Writefrac }

  { checks for multiple simplifications of the first fraction }
  if ai = 0
    then
      writeati (17,12,ai)
    else if ai = ci
      then
        writeati (17,12,1)
      else if ci = 1
        then
          writeati (17,12,ai)
        else
          begin  { else 1 }
            writeati (17,11,ai);
            writeatc (17,12,'-');
            writeati (17,13,ci);
          end;   { else 1 }

  { checks for multiple simplifications of the second fraction }
  if bi = 0
    then
      writeati (21,12,bi)
    else if bi = di
      then
        writeati (21,12,1)
      else if di = 1
        then
          writeati (21,12,bi)
        else
          begin  { else 2 }
            writeati (21,11,bi);
            writeatc (21,12,'-');
            writeati (21,13,di);
          end;  { else 2 }

End;  { Writefrac }

{****************************************************************************}

procedure Writeans;

{ writes out the answer in lowest form }
Begin  { Writeans }

  { sets up the basic form of the equation }
  gotoXY (2,12);
  write ('Solution ==>');
  writeatc (19,12,oper);
  writeatc (23,12,'=');

  { checks for multiple simplifications of the answer }
  if newnum = 0
    then
      writeati (25,12,newnum)
    else if newnum = newden
           then
             writeati (25,12,1)
           else if newden = 1
                  then
                    writeati (25,12,newnum)
                  else
                    if (newnum < 0) xor (newden < 0)
                      then
                        begin  { then }
                          writeatc (25,12,'-');
                          writeati (27,11,abs(newnum));
                          writeatc (27,12,'-');
                          writeatc (28,12,'-');
                          writeati (27,13,abs(newden));
                        end  { then }
                      else
                        begin  { else }
                          writeati (25,11,newnum);
                          writeatc (25,12,'-');
                          writeatc (26,12,'-');
                          writeati (25,13,newden);
                        end;  { else }

  { hides the cursor from the screen to make the screen look better }
  hide;

End;  { Writeans }

{****************************************************************************}

procedure Simplify;

{ simplifies the answer into its lowest form }
Begin  { Simplify }

  { assigns values to num and den }
  num := newnum;
  den := newden;

  { tests for newnum < newden and simplifies if true }
  if newnum < newden
    then

      begin  { then 1 }

        repeat   { testing 1 }

          { checks if the answer will be zero }
          if num = 0
            then
              writeans

            { if it doesn't equal zero then it begins simplifying it }
            else
              begin  { else 1 }
                gcf1 := newnum mod num;
                gcf2 := newden mod num;
                if gcf1 <> 0
                  then
                    num := num - 1
                  else
                    if gcf2 <> 0
                      then
                        num := num - 1;
              end;  { else 1 }

        { will repeat until both values equal zero, siganling a gcf }
        until (gcf1 = 0) and (gcf2 = 0);  { testing 1 }

        { checks to see if gcf doesn't equal the numerator or denomerator }
        if num <> 0
          then
            begin  { then 2 }
              newnum := trunc(newnum/num);
              newden := trunc(newden/num);
              writeans;
            end;   { then 2 }

      end;  { then 1 }

  { tests for newnum > newden and simplifies if true }
  if newnum > newden
    then

      begin  { then 3 }

        repeat  { testing 2 }

          { checks to see if answer will be zero }
          if num = 0
            then
              writeans

            { if not then it simplifies the answer }
            else
              begin  { else 2 }
                gcf1 := newnum mod den;
                gcf2 := newden mod den;
                if gcf1 <> 0
                  then
                    den := den - 1
                  else
                    if gcf2 <> 0
                      then
                        den := den - 1;
              end;  { else 2 }

        { will repeat until both values equal 0, signaling a gcf }
        until (gcf1 = 0) and (gcf2 = 0);  { testing 2 }

        { checks to see if gcf doesn't equal the numerator or denomerator }
        if den <> 0
          then
            begin  { then 4 }
              newnum := trunc(newnum/den);
              newden := trunc(newden/den);
              writeans;
            end;   { then 4 }
      end; { then 3 }

  { tests for newnum = newden and simplifies if true }
  if newnum = newden
    then  { then 5 }
      begin
        newnum := 1;
        newden := 1;
        writeans;
      end;  { then 5 }

  { holds output on screen so user can see it }
  readln;

End;  { Simplify }

{****************************************************************************}

procedure Case_state;

{ makes the decsion on what math to use depending upon the operator used }
Begin  { Case_state }

  { assigns the integer value of the char numbers for maniulation }
  ai := ord(a) - 48;
  ci := ord(c) - 48;
  bi := ord(b) - 48;
  di := ord(d) - 48;

  { tests for division by zero }
  if (ci = 0) or (di = 0)
    then
      begin  { then 1 }
        writeln;
        writeln (' I can not divide by zero.')
      end    { then 1 }

    { if ok then selects an operation to perform }
    else
      case oper of  { case oper }
        '+' : begin  { plus }
                newnum := (ai * di) + (bi * ci);
                newden := (ci * di);
                writefrac;
                simplify;
              end;  { plus }
        '-' : begin  {minus }
                newnum := (ai * di) - (bi * ci);
                newden := (ci * di);
                writefrac;
                simplify;
              end;  { minus }
        '*' : begin  { multiply }
                newnum := (ai * bi);
                newden := (ci * di);
                writefrac;
                simplify;
              end;  { multiply }
        '/' : begin  { division }
                newnum := (ai * di);
                newden := (bi * ci);
                writefrac;
                simplify;
              end;  { division }

        { checks to see if something was entered wrong or for passcode }
        else  begin  { else case }
                writeln;
                if a = 'e'
                  then
                    writeln (' Auf Wiederzehen')
                  else
                    writeln (' Improper operator.');
              end;  { else case }

      end;  { case oper }

End;  { Case_state }

{****************************************************************************}

procedure RUN;

{ integrates the entire program into this one procedure and runs it }
BEGIN  { RUN }

  { sets up the opening screen background }
  window (1,1,80,25);
  textbackground (1);
  clrscr;
  textbackground (0);
  for j := 1 to 40 do
    writeatc (j + 22,20,' ');
  for j := 1 to 13 do
    writeatc (61,j + 6,' ');
  for j := 1 to 13 do
    writeatc (62,j + 6,' ');
  window (21,6,60,19);

  { repeats the actual program until passcode is entered }
  repeat  { ruuning }

    { sets up the prompt }
    textcolor (0);
    textbackground (7);
    clrscr;
    writeln;
    writeln (' Enter the equation in this form:');
    writeln;
    writeln ('       a/c (+,-,*,/) b/d');
    writeln;
    writeln (' Only use single, positive integers.');
    writeln;
    write (' Enter the equation ==>  ');

    { reads the values entered one by one }
    read (a);
    read (nada);
    read (c);
    read (nada);
    read (oper);
    read (nada);
    read (b);
    read (nada);
    readln (d);

    { pulls the other procedures in }
    case_state;
    quit;

  { will continue to run until done equals true, thus needing the password }
  until done = true;  { running }

END;  { RUN }

{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}

begin  { main }

  run; { program }

end.   { main }




