{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} Unit OPTION; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



Uses CRT, WIEDER, POPUPS;

var
  count : byte;

procedure CLEANWIN   (x_position : byte; fix : string; choice : char);
procedure FILEWIN    (var cursor, menupos : byte; var choice : char);
procedure EDITWIN    (var cursor, menupos : byte; var choice : char);
procedure PRNTWIN    (var cursor, menupos : byte; var choice : char);
procedure EXITWIN    (var cursor, menupos : byte; var choice : char);
procedure HELPWIN    (var cursor, menupos : byte; var choice : char);
procedure MAKECHOICE (var cursor, menupos : byte; var choice : char);



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{=============================================================================}

{******** Clears the workspace and rewrites the section written over *********}

procedure CLEANWIN (x_position : byte; fix : string; choice : char);

Begin
  if (choice = #27) or (choice = #75) or (choice = #77) or
     (choice = #59) or (choice = #60) or (choice = #61) or
     (choice = #62) or (choice = #63)
    then
      begin
        clear (15,1,3,3,78,23);
        regwin;
        wrts (x_position,2,fix);
        hidecursor (1,1,7);
      end
    else hidecursor (1,1,3);
End;

{=============================================================================}

{*************** Run when the user selects the file option *******************}

procedure FILEWIN (var cursor, menupos : byte; var choice : char);

Begin
  menupos := 1;
  filemenu;
  selectbar (4,3,2,9,1,5,cursor,menupos,choice,chr(16),chr(17));
  cleanwin (4,'',choice);
End;

{=============================================================================}

{*************** Run when the user selects the edit option *******************}

procedure EDITWIN (var cursor, menupos : byte; var choice : char);

Begin
  menupos := 2;
  editmenu;
  selectbar (4,3,2,8,1,5,cursor,menupos,choice,chr(16),chr(17));
  cleanwin (13,'',choice);
End;

{=============================================================================}

{*************** Run when the user selects the print option ******************}

procedure PRNTWIN (var cursor, menupos : byte; var choice : char);

Begin
  menupos := 3;
  prntmenu;
  selectbar (4,3,2,10,1,3,cursor,menupos,choice,chr(16),chr(17));
  cleanwin (21,' Wie',choice);
End;

{=============================================================================}

{*************** Run when the user selects the exit option *******************}

procedure EXITWIN (var cursor, menupos : byte; var choice : char);

Begin
  menupos := 4;
  exitmenu;
  selectbar (4,3,2,9,1,2,cursor,menupos,choice,chr(16),chr(17));
  cleanwin (30,' WiederMenus 1',choice);
End;

{=============================================================================}

{*************** Run when the user selects the exit option *******************}

procedure HELPWIN (var cursor, menupos : byte; var choice : char);

Begin
  menupos := 5;
  helpmenu;
  selectbar (4,3,2,8,1,2,cursor,menupos,choice,chr(16),chr(17));
  cleanwin (63,'',choice);
End;

{=============================================================================}

{******** Controls what path is taken when the user selects an option ********}

procedure MAKECHOICE (var cursor, menupos : byte; var choice : char);

var
  openwin : boolean;

{#############################################################################}

{********************** Reads the users selection ****************************}

procedure readchoice;

Begin
  if openwin = false then choice := readkey;
End;

{#############################################################################}

{******* Run when the user presses <enter> and determines what is done *******}

procedure enter;

var
  exitoption : char;

Begin
  if openwin = true
    then
      begin
        case menupos of
          1 : case cursor of
                1 : open;
                2 : new;
                3 : save;
                4 : rename;
                5 : close;
              end;
          2 : case cursor of
                1 : edit;
                2 : copy;
                3 : cut;
                4 : paste;
                5 : color;
              end;
          3 : case cursor of
                1 : print;
                2 : options;
                3 : select;
              end;
          4 : case cursor of
                1 : choice := #27;
                2 : choice := #27;
              end;
          5 : case cursor of
                1 : about;
                2 : help;
              end;
        end;  { case menupos }
        hidecursor (1,1,3);
        if menupos <> 4
          then
            repeat
              exitoption := readkey;
            until (exitoption = #13) or (exitoption = #27);
        clear (1,1,3,3,78,23);
        regwin;
        case menupos of
          1 : filewin (cursor,menupos,choice);
          2 : editwin (cursor,menupos,choice);
          3 : prntwin (cursor,menupos,choice);
          4 : cleanwin (30,' WiederMenus 1',choice);
          5 : helpwin (cursor,menupos,choice);
        end;
      end;  { then }
End;

{#############################################################################}

{******* Run when the user presses <escape> and determines what is done ******}

procedure escape;

Begin
  if openwin = false
    then
      begin
        choice := #13;
        cursor := 2;
        menupos := 4;
      end;
  if openwin = true then openwin := false;
End;

{#############################################################################}

{****** Run when the user presses <alt> <f> and determines what is done ******}

procedure altf;

Begin
  menupos := 1;
  openwin := true;
  filewin (cursor,menupos,choice);
End;

{#############################################################################}

{****** Run when the user presses <alt> <e> and determines what is done ******}

procedure alte;

Begin
  menupos := 2;
  openwin := true;
  editwin (cursor,menupos,choice);
End;

{#############################################################################}

{****** Run when the user presses <alt> <p> and determines what is done ******}

procedure altp;

Begin
  menupos := 3;
  openwin := true;
  prntwin (cursor,menupos,choice);
End;

{#############################################################################}

{****** Run when the user presses <alt> <x> and determines what is done ******}

procedure altx;

Begin
  menupos := 4;
  openwin := true;
  exitwin (cursor,menupos,choice);
End;

{#############################################################################}

{****** Run when the user presses <alt> <h> and determines what is done ******}

procedure alth;

Begin
  menupos := 5;
  openwin := true;
  helpwin (cursor,menupos,choice);
End;

{#############################################################################}

{***** Run when the user presses left arrow and determines what is done ******}

procedure left;

Begin
  if openwin = true
    then
      begin
        dec(menupos);
        if menupos = 0 then menupos := 5;
        case menupos of
          1 : filewin (cursor,menupos,choice);
          2 : editwin (cursor,menupos,choice);
          3 : prntwin (cursor,menupos,choice);
          4 : exitwin (cursor,menupos,choice);
          5 : helpwin (cursor,menupos,choice);
        end;
      end;
End;

{#############################################################################}

{***** Run when the user presses right arrow and determines what is done *****}

procedure right;

Begin
  if openwin = true
    then
      begin
        inc(menupos);
        if menupos = 6 then menupos := 1;
        case menupos of
          1 : filewin (cursor,menupos,choice);
          2 : editwin (cursor,menupos,choice);
          3 : prntwin (cursor,menupos,choice);
          4 : exitwin (cursor,menupos,choice);
          5 : helpwin (cursor,menupos,choice);
        end;
      end;
End;

{#############################################################################}

Begin
  openwin := false;
  repeat
    if (choice = #33) or (choice = #18) or (choice = #25) or
       (choice = #45) or (choice = #59) or (choice = #60) or
       (choice = #61) or (choice = #62) or (choice = #63) or
       (choice = #75) or (choice = #77) or (openwin = false) then cursor := 1;
    readchoice;
    case choice of
      #13 : enter;
      #27 : escape;
      #33 : altf;
      #59 : altf;
      #18 : alte;
      #60 : alte;
      #25 : altp;
      #61 : altp;
      #45 : altx;
      #62 : altx;
      #35 : alth;
      #63 : alth;
      #75 : left;
      #77 : right
    end;
  until (choice = #13) and ((cursor = 2) and (menupos = 4));
End;

{=============================================================================}

END.  {*** Unit OPTION ***}