program movie;

{****************************************************************************
 *  Author  : Charlie Wiederhold                                            *
 *  Date    : 01/05/95                                                      *
 *  Purpose : This Program Determines the cost of a movie ticket.           *
 *              Customer : 12 or younger = $4.00 per ticket                 *
 *                         13 or older   = $5.50 per ticket                 *
 *  Method  : Write statements promt the user to enter the age of the       *
 *            customer, and an if/then statement is used to calculate       *
 *            the cost of the tickets ordered. The total is displayed on    *
 *            the screen to show the total cost of the tickets ordered.     *
 ****************************************************************************}

uses crt;

const
  twelve   = 4.00;  { cost of ticket for 12 and under }
  thirteen = 5.50;  { cost of ticket for 13 and older }

var
  age,                  { customer age variable }
  j,                    { output control variable }
  cust      : integer;  { number of customers }
  subtotal,             { subtotal for tickets }
  price,                { price of ticket for customer }
  totalcost : real;     { total cost for tickets }

{****************************************************************************}
procedure tctb (tc, tb : integer);

Begin  { tctb }

  { simplifies these two commands }
  textcolor (tc);
  textbackground (tb);

End;   { tctb}
{****************************************************************************}
procedure writeat (x,y : integer; strng : string);

Begin  { writeat }

  { simplifies these two commands }
  gotoXY (x,y);
  write (strng);

End;   { writeat }
{****************************************************************************}

Begin  { main }

  repeat
    begin  { repeat }

      { seting up the background screen }
      tctb (1,1);
      clrscr;
      tctb (0,0);
      for j := 1 to 61 do
        writeat (j + 11,21,'');
      for j := 1 to 15 do
        writeat (71,j + 5,'');
      window (10,5,70,20);
      tctb (0,7);
      clrscr;

      { setting up the opening screen }
      writeln;
      writeln (' Welcome to the South Freeway Cinema!');
      writeln (' We hope you enjoy your movie tonight!');
      writeln;
      writeln;
      writeln (' Ticket prices for this evening are:');
      writeln;
      write ('Under 13... $ ':35);
      tctb (1,7);
      writeln (twelve:0:2);
      tctb (0,7);
      write ('Adult...... $ ':35);
      tctb (1,7);
      writeln (thirteen:0:2);
      for j := 1 to 4 do
        writeln;

      { gathers the number of tickets bought }
      tctb (0,7);
      write (' How many customers do you need to purchase for: ');
      tctb (1,7);
      readln (cust);
      clrscr;

      { calculates the bill by the ages entered }
      if cust <> 0
        then
          begin  { then }
            tctb (0,7);
            writeln;
            writeln (' Enter the ages of all the customers needing tickets.');
            subtotal := 0;
            price := 0;

            { promts the user to enter ages }
            for j := 1 to cust do
              begin { for }
                tctb (0,7);
                writeat (1,j + 3,' Age of customer ');
                write (j, ' : ');
                tctb (1,7);
                readln (age);

                { calculates age twelve tickets }
                if age <= 12
                  then
                    begin { age twelve }
                      price := twelve;
                      tctb (5,7);
                      writeat (40,j + 3,'  $');
                      write (twelve:6:2);
                    end   { age twelve }

                  { calculates age thirteen }
                  else
                    begin { age thirteen }
                      price := thirteen;
                      tctb (5,7);
                      writeat (40,j + 3,'  $');
                      write (thirteen:6:2);
                    end;  { age thirteen }

                { adds the tickets together }
                subtotal := subtotal + price;
              end;  { for }

            { outputs the total }
            writeat (41,cust + 4,' -------');
            tctb (1,7);
            writeat (28,cust + 5,'Total cost :  $');
            write (subtotal:6:2);
          end; { then }

      { holds output and promts the user to hit enter to continue }
      tctb (0,7);
      writeat (1,16,' Press <Enter> to continue.');
      tctb (7,7);
      writeat (1,1,' ');
      gotoXY (1,1);
      readln;
    end; { repeat }

   { controls program running time }
   until cust = 0;

End. { main }
