program sport;

{****************************************************************************
 *   Author  : Charlie Wiederhold                                           *
 *   Date    : 01/05/95                                                     *
 *   Purpose : This program reads the temperature the user inputs, and      *
 *             matches it up with the sport it is compatible with.          *
 *                   Swimming : temp > 85                                   *
 *                   Tennis   : 70 .. 85                                    *
 *                   Golf     : 32 .. 70                                    *
 *                   Skiing   : 10 .. 32                                    *
 *                   Chess    : temp <= 10                                  *
 *   Method  : Write statements prompt the user to enter the temperature    *
 *             outside, and a case statement matches it up with the         *
 *             corresponding temperature.                                   *
 ****************************************************************************}

uses crt;

type
  sport_array = array [1..5] of string;  { array of the sports available }

var
  sprt : sport_array;  { sport variable }
  temp : real;         { temperature entered by user }
  j,                   { control variable for output }
  r : integer;         { control variable for output }

{****************************************************************************}
procedure writeat (x, y : integer; strng : string);

Begin  { writeat }

  { simplifies these two statements }
  gotoXY (x,y);
  write (strng);

End;   { writeat }
{****************************************************************************}
procedure tctb (tc, tb : integer);

Begin { tctb }

  { simplifies these two statements }
  textcolor (tc);
  textbackground (tb);

End;  { tctb }
{****************************************************************************}
Begin  { main }

  { assigns values to array }
  sprt[1] := 'Swimming';
  sprt[2] := 'Tennis  ';
  sprt[3] := 'Golf    ';
  sprt[4] := 'Skiing  ';
  sprt[5] := 'Checkers';

  repeat
    begin { repeat }

      { setting up opening background }
      tctb (1,1);
      clrscr;
      tctb (0,0);
      for j := 1 to 41 do
        writeat (j + 21,16,' ');
      for j := 1 to 10 do
        writeat (61,j + 5,'  ');
      tctb (0,7);
      window (20,5,60,15);
      clrscr;

      { gathers the inputed temperature from the user }
      writeln;
      write (' What is the temperature outside: ');
      readln (temp);

      { just for fun visual to simulate computer thinking }
      clrscr;
      writeln (' Deciding...');
      tctb (7,0);
      writeat (15,5,sprt[1]);
      tctb (0,7);
      for j := 2 to 5 do
        writeat (15,j + 4,sprt[j]);
      for r := 1 to 5 do
        for j := 1 to 5 do
          begin { for }
            if j <> 1
              then
                begin  { then }
                  tctb (7,0);
                  writeat (15,j + 4,sprt[j]);
                  tctb (0,7);
                  writeat (15,j + 3,sprt[j - 1]);
                  delay (200);
                end { then }
              else
                begin { else }
                  tctb (0,7);
                  writeat (15,9,sprt[5]);
                  tctb (7,0);
                  writeat (15,5,sprt[1]);
                  delay (200);
                end;  { else }
          end; { for }
      writeat (15,9,sprt[5]);

      { outputs the sport selected for the inputed info }
      tctb (7,0);
      if temp > 85
        then
          writeat (15,5,sprt[1])
        else
          if (temp > 70) and (temp <= 85)
            then
              writeat (15,6,sprt[2])
            else
              if (temp > 32) and (temp <= 70)
                then
                  writeat (15,7,sprt[3])
              else
                if (temp > 10) and (temp <= 32)
                  then
                    writeat (15,8,sprt[4])
                else
                  writeat (15,9,sprt[5]);
      tctb (0,7);
      writeat (1,1,' You should play the highlighted game.');
      tctb (7,7);
      writeat (1,1,' ');
      gotoXY (1,1);
      readln;
    end;  { repeat }
  until temp = 0;

End.  { main }