program student_info;

uses crt;

const
  a   = 4;
  b   = 3;
  c   = 2;
  f   = 1;
  reg = '';
  hon = 'H';
  col = 'CP';
  ap  = 'AP';

type
  string_array1 = array [1..7] of string[8];
  string_array2 = array [1..7] of string[8];
  boolean_array = array [1..7] of boolean;
  integer_array = array [1..7] of integer;
  grade___array = array [1..7,1..6] of integer;
  citizen_array = array [1..7,1..6] of char;
  stud_record = record
                  last_name,
                  first_name : string[10];
                  grade      : 9..12;
                  id_num     : longint;
                  teacher    : string_array1;
                  classes    : string_array2;
                  honors     : string_array2;
                  grades     : grade___array;
                  citizen    : citizen_array;
                  exempt     : boolean_array;
                  sem1_ave,
                  sem2_ave,
                  sem1_final,
                  sem2_final,
                  year_final,
                  sem1_exam,
                  sem2_exam,
                  gpa_sem1,
                  gpa_sem2   : integer_array;
                  sem1_tot,
                  sem2_tot,
                  year_tot   : integer;
                  sem1_gpa,
                  sem2_gpa,
                  gpa_total  : real;
                end;

var
  stud      : stud_record;
  periods,
  counter,
  count     : integer;
  exemption : char;

{*****************************************************************************}
procedure initialize;
begin
  with stud do
    begin
      for counter := 1 to 7 do
        for count := 1 to 6 do
          grades[counter,count] := 0;
      for count := 1 to 7 do
        begin
          sem1_exam[count] := 0;
          sem2_exam[count] := 0;
          sem1_ave[count] := 0;
          sem2_ave[count] := 0;
          sem1_final[count] := 0;
          sem2_final[count] := 0;
          year_final[count] := 0;
          gpa_sem1[count] := 0;
          gpa_sem2[count] := 0;
          exempt[count] := true;
          honors[count] := reg;
        end;
      sem1_tot := 0;
      sem2_tot := 0;
      year_tot := 0;
      sem1_gpa := 0;
      sem2_gpa := 0;
      gpa_total := 0;
    end;
end;
{*****************************************************************************}
procedure get_student;

{ Gets the students initial information }
var
  honor : char;
begin
  textcolor (7);
  textbackground (1);
  clrscr;
  writeln;
  with stud do
    begin
      write (' Enter the student''s first name: ');
      readln (first_name);
      write (' Enter the student''s last name: ');
      readln (last_name);
      write (' Enter the current grade for the student (9,10,11, or 12): ');
      readln (grade);
      write (' Enter the students ID number: ');
      readln (id_num);
      write (' Enter the number of periods the student has: ');
      readln (periods);

      { Gets the students teachers and classes }
      for count := 1 to periods do
        begin
          clrscr;
          writeln;
          writeln (' Information on: ', first_name, ' ', last_name);
          writeln;
          write (' Enter teacher for period ', count, ' (Only 8 letters used): ');
          readln (teacher[count]);
          write (' Enter the class for period ', count, ' (Only 8 letters used): ');
          readln (classes[count]);
          writeln (' What type is the classification of the class?');
          write (' Regular <r>, Honors <h>, College Prep <c>, or AP <a>): ');
          readln (honor);
          case honor of
            'r' : honors[count] := reg;
            'h' : honors[count] := hon;
            'c' : honors[count] := col;
            'a' : honors[count] := ap;
          end;
        end;
    end;
end;
{***************************************************************************}
procedure get_grades;
begin
  with stud do
    begin
      for count := 1 to 6 do
        begin
          for counter := 1 to periods do
            begin
              clrscr;
              writeln;
              writeln (' Six Weeks ', count);
              writeln (' -----------');
              writeln;
              writeln (' Enter the grades.');
              writeln;

              { Gets the students grades in all classes }
              write (' Grade for ', classes[counter], ': ');
              readln (grades[counter,count]);
              write (' Citizenship grade: ');
              readln (citizen[counter,count]);
              case count of
                3 : begin
                      write (' Semester One Exam: ');
                      readln (sem1_exam[counter]);
                    end;
                6 : begin
                      write (' Is the student exempt from the semester exam? (Y/N)');
                      readln (exemption);
                      if exemption = 'n'
                        then
                          begin
                            exempt[counter] := false;
                            write (' Semester Two Exam: ');
                            readln (sem2_exam[counter]);
                          end
                        else exempt[count] := true;
                    end;
              end;
            end;
        end;
      end;
end;
{***************************************************************************}
procedure calc_grades;
begin
  with stud do
    begin
      for count := 1 to periods do
        begin
          sem1_ave[count] := grades[count,1] + grades[count,2] + grades[count,3];
          sem2_ave[count] := grades[count,4] + grades[count,5] + grades[count,6];
        end;
      for count := 1 to periods do
        begin
          sem1_ave[count] := round(sem1_ave[count] / 3);
          sem2_ave[count] := round(sem2_ave[count] / 3);
        end;
      for count := 1 to periods do
        begin
          sem1_final[count] := round(((5 * sem1_ave[count]) + sem1_exam[count]) / 6);
          if exempt[count] = false
            then sem2_final[count] := round(((5 * sem2_ave[count]) + sem2_exam[count]) / 6)
            else sem2_final[count] := sem2_ave[count];
        end;
      for count := 1 to periods do
        begin
          sem1_tot := sem1_tot + sem1_final[count];
          sem2_tot := sem2_tot + sem2_final[count];
        end;
      sem1_tot := round(sem1_tot / periods);
      sem2_tot := round(sem2_tot / periods);
      for count := 1 to 6 do
        year_final[count] := round((sem1_final[count] + sem2_final[count]) / 2);
      for count := 1 to periods do
        year_tot := year_tot + year_final[count];
      year_tot := round(year_tot / 2);
    end;
end;
{***************************************************************************}
procedure calc_gpa;
begin
  with stud do
    begin
      for count := 1 to periods do
        begin
          case sem1_final[count] of
            90..100 : gpa_sem1[count] := a;
            80..89  : gpa_sem1[count] := b;
            70..79  : gpa_sem1[count] := c;
            0..69   : gpa_sem1[count] := f;
          end;
          if (honors[count] = hon) or
             (honors[count] = col) or
             (honors[count] = ap)
               then gpa_sem1[count] := gpa_sem1[count] + 1;
          case sem2_final[count] of
            90..100 : gpa_sem2[count] := a;
            80..89  : gpa_sem2[count] := b;
            70..79  : gpa_sem2[count] := c;
            0..69   : gpa_sem2[count] := f;
          end;
          if (honors[count] = hon) or
             (honors[count] = col) or
             (honors[count] = ap)
               then gpa_sem2[count] := gpa_sem2[count] + 1;
        end;
    for count := 1 to periods do
      begin
        sem1_gpa := sem1_gpa + gpa_sem1[count];
        sem2_gpa := sem2_gpa + gpa_sem2[count];
      end;
    sem1_gpa := sem1_gpa / periods;
    sem2_gpa := sem2_gpa / periods;
    gpa_total := (sem1_gpa + sem2_gpa) / 2;
  end;
end;
{***************************************************************************}
procedure output_data;
begin
  with stud do
    begin
      textbackground (0);
      clrscr;
      textbackground (5);
      window (26,2,55,6);
      clrscr;
      gotoXY (1,2);
      writeln (' Name: ', last_name, ', ', first_name);
      writeln;
      writeln (' Grade: ', grade, '   ID Number: ', id_num);
      textbackground (7);
      window (1,8,80,17);
      clrscr;
      textbackground (5);
      window (1,8,10,17);
      clrscr;
      for count := 21 to 80 do
        begin
          window (count,8,count + 4,17);
          clrscr;
          count := count + 9;
        end;
      textcolor (0);
      textbackground (3);
      window (1,1,80,25);
      gotoXY (1,8);
      write (' Teacher   Class    Level 1st  2nd  3rd Exam Sem1  4th  5th  6th Exam Sem2 Year ');
      textcolor (7);
      textbackground (5);
      for count := 1 to periods do
        begin
          gotoXY (2,count + 9);
          writeln (teacher[count]);
        end;
      for count := 1 to periods do
        begin
          gotoXY (22,count + 9);
          writeln (honors[count]:2);
        end;
      for count := 1 to periods do
        begin
          gotoXY (32,count + 9);
          writeln (grades[count,2]:3);
        end;
      for count := 1 to periods do
        begin
          gotoXY (42,count + 9);
          writeln (sem1_exam[count]:3);
        end;
      for count := 1 to periods do
        begin
          gotoXY (52,count + 9);
          writeln (grades[count,4]:3);
        end;
      for count := 1 to periods do
        begin
          gotoXY (62,count + 9);
          writeln (grades[count,6]:3);
        end;
      for count := 1 to periods do
        begin
          gotoXY (72,count + 9);
          writeln (sem2_final[count]:3);
        end;
      textcolor (5);
      textbackground (7);
      for count := 1 to periods do
        begin
          gotoXY (12,count + 9);
          writeln (classes[count]);
        end;
      for count := 1 to periods do
        begin
          gotoXY (27,count + 9);
          writeln (grades[count,1]:3);
        end;
      for count := 1 to periods do
        begin
          gotoXY (37,count + 9);
          writeln (grades[count,3]:3);
        end;
      for count := 1 to periods do
        begin
          gotoXY (47,count + 9);
          writeln (sem1_final[count]:3);
        end;
      for count := 1 to periods do
        begin
          gotoXY (57,count + 9);
          writeln (grades[count,5]:3);
        end;
      for count := 1 to periods do
        begin
          gotoXY (67,count + 9);
          writeln (sem2_exam[count]:3);
        end;
      for count := 1 to periods do
        begin
          gotoXY (77,count + 9);
          writeln (year_final[count]:3);
        end;
      textcolor (7);
      textbackground (5);
      window (28,19,52,24);
      clrscr;
      gotoXY (1,2);
      writeln (' Gpa 1st semester: ', sem1_gpa:0:3);
      writeln (' Gpa 2nd semester: ', sem2_gpa:0:3);
      writeln;
      writeln (' Gpa for the year: ', gpa_total:0:3);
      textcolor (5);
      gotoXY (1,1);
      write (' ');
      gotoXY (1,1);
      readln;
    end;
end;
{***************************************************************************}
begin
  initialize;
  get_student;
  get_grades;
  calc_grades;
  calc_gpa;
  output_data;
end.
