{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT UTILITY; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



USES CRT;

  Procedure TCTB       (tc, tb : byte);
  Procedure WRTC       (x, y : byte; chr : char);
  Procedure WRTS       (x, y : byte; str : string);
  Procedure WRTI       (x, y : byte; int : integer);
  Procedure WRTR       (x, y : byte; reel : real; field, decimal : byte);
  Procedure FRMTI      (x, y : byte; int : integer; field : byte);
  Procedure REGWIN;
  Procedure CLEAR      (text, backcolor, ulx, uly, lrx, lry : byte);
  Procedure MAKEWIN    (shadow, border : boolean;
                        bordercolor, borderstyle,
                        text, background, ulx, uly, width, height : byte);
  Procedure HIDECURSOR (x, y, color : byte);
  Procedure SELECTBAR  (text, background, width, height : byte;
                        var cursor : byte; var choice : char);



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{=============================================================================}

{****** Combines the textcolor textbackground commands into one command ******}

Procedure TCTB (tc, tb : byte);

Begin
  textcolor (tc);
  textbackground (tb);
End;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

Procedure WRTC (x, y : byte; chr: char);

Begin
  gotoXY (x, y);
  write (chr);
End;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

Procedure WRTS (x, y : byte; str : string);
Begin
  gotoXY (x, y);
  write (str);
End;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

Procedure WRTI (x, y : byte; int : integer);

Begin
  gotoXY (x, y);
  write (int);
End;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

Procedure WRTR (x, y : byte; reel : real; field, decimal : byte);

Begin
  gotoXY (x, y);
  write (reel:field:decimal);
End;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

Procedure FRMTI (x, y : byte; int: integer; field : byte);

Begin
  gotoXY (x,y);
  write (int:field);
End;

{=============================================================================}

{*************** Resizes to standard window without clearing it **************}

Procedure REGWIN;

Begin
  window (1,1,80,25);
End;

{=============================================================================}

{***************** Redraws the standard window and clears it *****************}

Procedure CLEAR (text, backcolor, ulx, uly, lrx, lry : byte);

Begin
  TCTB (text, backcolor);
  window (ulx,uly,lrx,lry);
  clrscr;
End;

{=============================================================================}

{***************** Redraws the specified window and clears it ****************}

Procedure MAKEWIN (shadow, border : boolean;
                   bordercolor, borderstyle,
                   text, background, ulx, uly, width, height : byte);
var
  count : byte;

begin
  if shadow
    then CLEAR (0, 0, (ulx + 2), (uly + 1),
                (ulx + (width + 1)), (uly + height));
  CLEAR (text, background, ulx, uly, ulx + (width - 1), uly + (height - 1));
{  if border
    then
      begin
        TCTB (bordercolor,background);
        REGWIN;
        for count := (ulx + 2) to (lrx - 2) do
          begin
            WRTC (count,uly,chr(205));
            WRTC (count,lry,chr(205));
          end;
        for count := (uly + 1) to (lry - 1) do
          begin
            WRTC ((ulx + 1),count,chr(186));
            WRTC ((lrx - 1),count,chr(186));
          end;
        WRTC ((ulx + 1),uly,chr(201));
        WRTC ((lrx - 1),uly,chr(187));
        WRTC ((ulx + 1),lry,chr(200));
        WRTC ((lrx - 1),lry,chr(188));
      end;
    window ((ulx + 2), (uly + 1), (lrx - 2), (lry - 1));}
    TCTB (text,background);

end;

{=============================================================================}

{****************************** Hides the cursor *****************************}

Procedure HIDECURSOR (x, y, color : byte);

Begin
  TCTB (color, color);
  WRTC (x, y, ' ');
  gotoXY (x,y);
End;

{=============================================================================}

{******************* Moves about in a vertical selection bar *****************}

Procedure SELECTBAR (text, background, width, height : byte;
                     var cursor : byte; var choice : char);

Begin
  TCTB (text, background);
  WRTC (2, cursor, #16);
  WRTC ((width + 3), cursor, #17);
  repeat
    HIDECURSOR (1, cursor, background);
    choice := readkey;
    case choice of
      #80 : begin
              TCTB (background, background);
              WRTC (2, cursor, ' ');
              WRTC ((width + 3), cursor, ' ');
              if cursor = height
                then cursor := 1
                else inc(cursor);
              TCTB (text, background);
              WRTC (2, cursor, #16);
              WRTC ((width + 3), cursor, #17);
            end;
      #72 : begin
              TCTB (background, background);
              WRTC (2, cursor, ' ');
              WRTC ((width + 3), cursor, ' ');
              if cursor = 1
                then cursor := height
                else dec(cursor);
              TCTB (text, background);
              WRTC (2, cursor, #16);
              WRTC ((width + 3), cursor, #17);
            end;
      #33 : choice := #59;
      #30 : choice := #60;
      #31 : choice := #61;
      #47 : choice := #62;
      #18 : choice := #63;
      #35 : choice := #64;
    end;  { case }
  until (choice = #13) or (choice = #27) or (choice = #45) or
        ((choice >= #59) and (choice <= #64)) or
        (choice = #75) or (choice = #77);

End;

{=============================================================================}

END.  {*** UNIT WIEDER ***}