{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT WGHELP; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



USES CRT, UTILITY;

Var
  chrc : char;

  Procedure HELP  (wincolor,wintext,winborder : byte);
  Procedure ABOUT (wincolor,wintext,winborder,menupos : byte);



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{=============================================================================}

{***************** Creates the window for WiederGrades help ******************}

Procedure HELPWIN (wincolor, wintext, winborder : byte);

Begin
  MAKEWIN (wintext,wincolor,15,4,65,22,true,true,winborder);
  REGWIN;
  TCTB (8,0);
  WRTC (67,5,'A');
  WRTS (66,6,'');
  TCTB (winborder,7);
  WRTS (32,4,' WiederGrades Help ');
  window (18,5,63,21);
End;

{=============================================================================}

{************* Draws the page up and page down in the window *****************}

Procedure PAGEUPDN (wincolor,winborder,pagepos : byte);

Begin
  REGWIN;
  TCTB (winborder,wincolor);
  WRTS (55,22,'');
  TCTB (14,7);
  if (pagepos < 6) and (pagepos > 1) then WRTS (55,22,'PgUp/PgDn');
  if pagepos = 1 then WRTS (60,22,'PgDn');
  if pagepos = 6 then WRTS (60,22,'PgUp');
  window (18,5,62,21);
End;

{=============================================================================}

{******************* Creates Page 1 of WiederGrades help *********************}

Procedure PAGE1;

Begin
  TCTB (1,7);
  writeln (' File Menu');
  writeln ('---------------------------------------------');
  writeln ('Load');
  TCTB (0,7);
  writeln (' Loads the period selected');
  TCTB (1,7);
  writeln;
  writeln ('Print');
  TCTB (0,7);
  writeln (' Class Report : Single report of entire class');
  writeln (' One Student  : Ind. report of one student');
  writeln (' All Students : Ind. reports of entire class');
  TCTB (1,7);
  writeln;
  writeln ('New');
  TCTB (0,7);
  writeln (' New Six Weeks: Clear grades and averages');
  writeln (' New Year     : Clear everything');
  TCTB (1,7);
  writeln;
  writeln ('Exit');
  TCTB (0,7);
  write   (' Exit WiederGrades');
End;

{=============================================================================}

{******************* Creates Page 2 of WiederGrades help *********************}

Procedure PAGE2;

Begin
  TCTB (1,7);
  writeln (' Add Menu');
  writeln ('---------------------------------------------');
  writeln ('Students');
  TCTB (0,7);
  writeln (' Add students to the class roll');
  TCTB (1,7);
  writeln;
  writeln ('DailyNames');
  TCTB (0,7);
  writeln (' Add daily grade names for assignments');
  TCTB (1,7);
  writeln;
  writeln ('TestNames');
  TCTB (0,7);
  writeln (' Add test grade names for assignments');
  writeln;
  TCTB (1,7);
  writeln ('DailyGrades');
  TCTB (0,7);
  writeln (' Enter daily grades for students');
  TCTB (1,7);
  writeln;
  writeln ('TestGrades');
  TCTB (0,7);
  write   (' Enter test grades for students');
End;

{=============================================================================}

{******************* Creates Page 3 of WiederGrades help *********************}

Procedure PAGE3;

Begin
  TCTB (1,7);
  writeln (' Search Menu');
  writeln ('---------------------------------------------');
  writeln ('FirstName');
  TCTB (0,7);
  writeln (' Search for a student by first name');
  TCTB (1,7);
  writeln;
  writeln ('LastName');
  TCTB (0,7);
  writeln (' Search for a student by last name');
  TCTB (1,7);
  writeln;
  writeln ('IDNumber');
  TCTB (0,7);
  writeln (' Search for a student by ID number');
  writeln;
  writeln;
  writeln (' Each option lists the students with');
  writeln (' matching names and their averages, or');
  writeln (' states that no matches were found if none');
  write   (' of the students match the target.');
End;

{=============================================================================}

{******************* Creates Page 4 of WiederGrades help *********************}

Procedure PAGE4;

Begin
  TCTB (1,7);
  writeln (' View Menu');
  writeln ('---------------------------------------------');
  TCTB (1,7);
  writeln ('AllAverages');
  TCTB (0,7);
  writeln (' Displays a maximum of 20 students per page,');
  writeln (' showing their ID numbers and averages.');
  writeln (' The other 20 students can be seen by');
  writeln (' pressing PgUp or PgDn to flip through');
  writeln (' the student information.');
  TCTB (1,7);
  writeln;
  writeln;
  writeln ('ClassGrades');
  TCTB (0,7);
  writeln (' Displays a maximum of 20 students per');
  writeln (' page, showing the current grade position,');
  writeln (' student position, class average, and student');
  writeln (' average.');
  writeln (' All grades may be edited from this option.');
End;

{=============================================================================}

{******************* Creates Page 5 of WiederGrades help *********************}

Procedure PAGE5;

Begin
  TCTB (1,7);
  writeln (' Edit Menu');
  writeln ('---------------------------------------------');
  write   ('Name        : ');
  TCTB (0,7);
  writeln ('Edit student name');
  TCTB (1,7);
  write   ('IDNumber    : ');
  TCTB (0,7);
  writeln ('Edit student ID number');
  TCTB (1,7);
  writeln;
  write   ('DailyGrades : ');
  TCTB (0,7);
  writeln ('Edit student daily grade');
  TCTB (1,7);
  write   ('TestGrades  : ');
  TCTB (0,7);
  writeln ('Edit student test grade');
  TCTB (1,7);
  writeln;
  write   ('DailyNames  : ');
  TCTB (0,7);
  writeln ('Edit daily grade name');
  TCTB (1,7);
  write   ('TestNames   : ');
  TCTB (0,7);
  writeln ('Edit test grade name');
  TCTB (1,7);
  writeln;
  write   ('CurveDaily  : ');
  TCTB (0,7);
  writeln ('Curve a daily grade');
  TCTB (1,7);
  write   ('CurveTest   : ');
  TCTB (0,7);
  writeln ('Curve a test grade');
  TCTB (1,7);
  writeln;
  write   ('DropLowGrade: ');
  TCTB (0,7);
  writeln ('Drop all student''s lowest grade');
  TCTB (1,7);
  write   ('ClassName   : ');
  TCTB (0,7);
  write   ('Edit class name');
End;

{=============================================================================}

{******************* Creates Page 6 of WiederGrades help *********************}

Procedure PAGE6;

Begin
  TCTB (1,7);
  writeln (' Menu Key Strokes');
  writeln ('---------------------------------------------');
  write   ('<ALT F>  or  <F1>  ==>  ');
  TCTB (0,7);
  writeln ('Open File Menu');
  TCTB (1,7);
  write   ('<ALT A>  or  <F2>  ==>  ');
  TCTB (0,7);
  writeln ('Open Add Menu');
  TCTB (1,7);
  write   ('<ALT S>  or  <F3>  ==>  ');
  TCTB (0,7);
  writeln ('Open Search Menu');
  TCTB (1,7);
  write   ('<ALT V>  or  <F4>  ==>  ');
  TCTB (0,7);
  writeln ('Open View Menu');
  TCTB (1,7);
  write   ('<ALT E>  or  <F5>  ==>  ');
  TCTB (0,7);
  writeln ('Open Edit Menu');
  TCTB (1,7);
  write   ('<ALT H>  or  <F6>  ==>  ');
  TCTB (0,7);
  writeln ('Open Help Menu');
  TCTB (1,7);
  writeln;
  writeln;
  writeln (' Exit Option Key Strokes');
  writeln ('---------------------------------------------');
  write   ('<ESC>       ==>  ');
  TCTB (0,7);
  writeln ('Exit a menu');
  TCTB (1,7);
  write   ('<X> or <x>  ==>  ');
  TCTB (0,7);
  writeln ('Exit from options when');
  writeln ('                 entering data');
  TCTB (1,7);
  write   ('<ALT X>     ==>  ');
  TCTB (0,7);
  writeln ('Exit WiederGrades');
End;

{=============================================================================}

{************************ Runs WiederGrades Help *****************************}

Procedure HELP (wincolor,wintext,winborder : byte);

var
  pagepos : byte;

Begin
  pagepos := 1;
  HELPWIN (wincolor,wintext,winborder);
  PAGE1;
  repeat
    PAGEUPDN (wincolor,winborder,pagepos);
    HIDECURSOR (1,1,7);
    repeat
      chrc := readkey;
    until (chrc = #27) or (chrc = #73) or (chrc = #81);
    if chrc = #81 then inc(pagepos);
    if pagepos = 7 then pagepos := 6;
    if chrc = #73 then dec(pagepos);
    if pagepos = 0 then pagepos := 1;
    CLEAR (0,7,18,5,63,21);
    case pagepos of
      1 : PAGE1;
      2 : PAGE2;
      3 : PAGE3;
      4 : PAGE4;
      5 : PAGE5;
      6 : PAGE6;
    end;
  until chrc = #27;
  CLEAR (15,1,4,3,77,24);
End;

{=============================================================================}

{*********************** Creates the about window ****************************}

Procedure ABOUT (wincolor,wintext,winborder,menupos : byte);

Begin
  MAKEWIN (wintext,wincolor,19,5,65,21,true,true,winborder);
  REGWIN;
  TCTB (8,0);
  if menupos = 6 then WRTS (66,6,'');
  TCTB (winborder,wincolor);
  WRTS (36,5,' WiederGrades ');
  TCTB (wintext,wincolor);
  window (22,6,63,20);
  writeln;
  writeln ('Author............. Charles T. Wiederhold');
  writeln ('                    224 Prairie View');
  writeln ('                    Crowley, Texas 76036');
  writeln ('                    (817) 297 - 6890');
  writeln;
  writeln ('Written For........ Crowley High School');
  writeln ('                    1005 W. Main');
  writeln ('                    Crowley, Texas 76036');
  writeln ('                    (817) 297 - 5810');
  writeln;
  writeln ('Date............... Spring 1995');
  writeln;
  write   ('Version............ WiederGrades ver 1.0');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := readkey;
  until chrc = #27;
  CLEAR (15,1,4,3,77,24);
End;

{=============================================================================}

END.  {*** UNIT WGHELP ***}