UNIT DiskUtil;

INTERFACE

USES
  Utility,
  InstData;

TYPE
  LargeBufType = ARRAY [1..64000] OF Char;

VAR
  LargeBuf : ^LargeBufType;

PROCEDURE CopyFile (FileName, Source, Destination : STRING; VAR PercentDone : Real;
                    TotalBytes : LongInt);

IMPLEMENTATION

{***************************************************************************}
PROCEDURE CopyFile (FileName, Source, Destination : STRING; VAR PercentDone : Real;
                    TotalBytes : LongInt);

VAR
  FromF,
  ToF          : FILE;
  NumRead,
  NumWritten   : Word;
  Count,
  XPos         : Byte;

BEGIN
  new (LargeBuf);
  assign(FromF, Source + FileName);
  reset(FromF, 1);
  assign(ToF, Destination + FileName);
  rewrite(ToF, 1);
  REPEAT
    blockread(FromF, LargeBuf^, SizeOf(LargeBuf^), NumRead);
    blockwrite(ToF, LargeBuf^, NumRead, NumWritten);
    PercentDone := PercentDone + (NumRead/TotalBytes);
    XPos := (round(PercentDone * 100) DIV 2 + 9);
    IF (round(PercentDone * 100) MOD 2) = 0 THEN
      BEGIN
        TcTb (14,1);
        FrmtI (56,3,round(PercentDone * 100),3);
      END;
    TcTb (14,0);
    IF XPos > 9 THEN FOR Count := 10 TO XPos DO WrtC (Count,4,'');
  UNTIL (NumRead = 0) OR (NumWritten <> NumRead);
  close(FromF);
  close(ToF);
  dispose (LargeBuf);
END;

{***************************************************************************}

END.