{$M $4000,0,65535}
PROGRAM DukeVacationInstall;

USES
  NewDelay,
  Crt,
  Dos,
  Menus,
  Utility,
  DiskUtil,
  InstData;

VAR
  Error     : Byte;
  ErrorInfo : STRING;
  GamerExist,
  Quit      : Boolean;
  ReadChar,
  BootDrive : Char;
  OrigMode  : Integer;
  DirInfo   : SearchRec;

{*********************************************f******************************}
PROCEDURE ReadPath (XStart, YStart, Width : Byte; VAR NewStr : PathType);

VAR
  Charac : Char;
  Count  : Byte;
  Exit   : Boolean;

BEGIN
  Clear (15 + 16,0,XStart,YStart,XStart + Width + 1,YStart);
  Window (XStart + 1,YStart,XStart + Width + 1,YStart);
  NewStr := '                                                            ';
  gotoXY (1,1);
  Exit := False;
  Count := 0;
  CursorOn;
  WHILE NOT Exit DO
     BEGIN
       Charac := upcase(readkey);
       IF Charac = #0 THEN
           BEGIN
             Charac := upcase(readkey);
             IF Charac = 'K' THEN
                 Charac := #8
               ELSE Charac := #255;
           END;
       IF (Charac IN [#33..#126]) AND (Count IN [0..Width - 1]) THEN
           BEGIN
             inc(Count);
             NewStr[Count] := Charac;
             WrtS (Count,1,NewStr[Count]);
             IF Count = Width THEN GotoXY (Count,1);
           END
         ELSE
           IF (Charac = #8) AND (Count >= 1) THEN
               BEGIN
                 NewStr[Count] := ' ';
                 WrtS (Count,1,NewStr[Count]);
                 GotoXY (Count,1);
                 dec(Count);
               END
             ELSE
               IF (Charac = #13) OR (Charac=#27) THEN
                   BEGIN
                     Exit := True;
                     IF Charac = #27 THEN NewStr := 'EXITED';
                   END
                 ELSE
                   IF (Charac = #0) THEN
                     ELSE Beep (1000,50);
     END;
  CursorOff;
  delete (NewStr,pos(' ',NewStr),length(NewStr));
  WHILE (NewStr[length(NewStr)] = '\') DO delete (NewStr,length(NewStr),1);
END;

{***************************************************************************}
PROCEDURE InstallAddon
  (FileList     : FileArray;
   GameVersion  : STRING;
   GamePath,
   GamerPath : PathType);

VAR
  NewIniFile,
  IniFile     : Text;
  GameTitle,
  AddonDir,
  TempStr,
  SearchStr   : STRING;
  TempFile    : FILE;
  TempByte    : Byte;
  TempChar    : Char;
  Count       : 1..NumFiles;
  TotalBytes  : LongInt;
  GamerVersion,
  PercentDone : Real;

BEGIN

{////////////////////////////////////////////////////////////////////////////}
{ ADDON DEPENDENT... CHANGES WITH EVERY ADD-ON }

  {Finds the version of the game and determines what version of the addon
  needs to be installed... if there are different versions. Most likely
  is drastically different for each different game }

  {Not sure if I will need this... currently not needed}
  IF GameVersion = '13' THEN GameTitle := Game_Title + ' 1.3D';
  IF GameVersion = 'PP' THEN GameTitle := Game_Title + ' ATOMIC';
  IF GameVersion = '15' THEN GameTitle := Game_Title + ' ATOMIC!';
  AddonDir := Game_Short + GameVersion;
  FileList[1] := FileList[1] + GameVersion + '.SSI';
{////////////////////////////////////////////////////////////////////////////}

  InstallScreenSetup (GamerPath);
  IF NOT EnoughSpace (GamerPath) THEN
      BEGIN
        Quit := True;
        Error := 2;
        Exit;
      END;

  IF NOT GamerExist THEN
      BEGIN
        findfirst (GamerPath,AnyFile,DirInfo);
        IF DOSError <> 0 THEN mkdir (GamerPath);
        findfirst (GamerPath + '\' + AddonDir,AnyFile,DirInfo);
        IF DOSError <> 0 THEN mkdir (GamerPath + '\' + AddonDir);

        assign (NewIniFile,GamerPath + '\GAMER.INI');
        rewrite (NewIniFile);
        writeln (NewIniFile,'// This is the initialization file for the "Game Add-on Manager" software.');
        writeln (NewIniFile,'// Please do not delete this file, as you will NOT be able to run GAMER.');
        writeln (NewIniFile,'// Should you choose to delete it... well, tough luck.');
        writeln (NewIniFile,'// For those of you who must edit INI files, here is what each line means:');
        writeln (NewIniFile,'//');
        writeln (NewIniFile,'// Line 1 - The version number of the GAMER software installed.');
        writeln (NewIniFile,'//          If you change this, then you are a goofball.');
        writeln (NewIniFile,'// Line 2 - The current number of games you have add-ons installed for.');
        writeln (NewIniFile,'//');
        writeln (NewIniFile,'// Then, each following section is broken into groups for info on each game:');
        writeln (NewIniFile,'// Group Line 1 - The title of the game. (diff. versions have diff. titles)');
        writeln (NewIniFile,'// Group Line 2 - The subdirectory of GAMER where the addons for the games');
        writeln (NewIniFile,'//                are located.');
        writeln (NewIniFile,'// Group Line 3 - The title of the currently activated add-on pack.');
        writeln (NewIniFile,'//                (NONE means that NONE are installed... silly)');
        writeln (NewIniFile,'// Group Line 4 - The directory where that game is installed. Should you');
        writeln (NewIniFile,'//                choose to move the game... you need to change that info.');
        writeln (NewIniFile,'//');
        writeln (NewIniFile,'// Well, I hope I have satisfied your curiosity. Oh yeah, don''t delete any of');
        writeln (NewIniFile,'// these lines of text, as I wanted to make sure they remained in every last');
        writeln (NewIniFile,'// copy of GAMER installed on every computer. If you get rid of them, GAMER');
        writeln (NewIniFile,'// simply won''t work. :^) To quote everyone''s favorite movie "I WARNED YA!"');
        writeln (NewIniFile,'//');
        writeln (NewIniFile,'// Charlie Wiederhold - Sunstorm Interactive, Inc.');
        writeln (NewIniFile,'// I was kidding about deleting other lines. Just please don''t change/delete');
        writeln (NewIniFile,'// the next line that says "End of text header". Honest!');
        writeln (NewIniFile,'// End of text header');

        GamerVersion := 0.0;
        writeln (NewIniFile,New_Gamer_Version:0:2);
        writeln (NewIniFile,'1');
        writeln (NewIniFile,GameTitle);
        writeln (NewIniFile,AddonDir);
        writeln (NewIniFIle,'NONE');
        writeln (NewIniFile,GamePath + '\');
        close (NewIniFile);
        SetFAttr (NewIniFile,Archive);
      END
    ELSE
      BEGIN
        assign (IniFile,GamerPath + '\GAMER.INI');
        assign (NewIniFile,GamerPath + '\GAMER.IN_');
        reset (IniFile);
        REPEAT
          readln (IniFile,SearchStr);
        UNTIL (SearchStr = GameTitle) OR Eof(IniFile);
        reset (IniFile);
        rewrite (NewIniFile);
        REPEAT
          readln (IniFile,TempStr);
          writeln (NewIniFile,TempStr);
        UNTIL (TempStr = '// End of text header');
        readln (IniFile,GamerVersion);
        IF GamerVersion >= New_Gamer_Version THEN
            writeln (NewIniFile,GamerVersion:0:2)
          ELSE writeln (NewIniFile,New_Gamer_Version:0:2);
        readln (IniFile,TempByte);
        IF SearchStr = GameTitle THEN
            writeln (NewIniFile,TempByte)
          ELSE writeln (NewIniFile,TempByte + 1);
        IF SearchStr = GameTitle THEN
            BEGIN
              REPEAT
                readln (IniFile,TempStr);
                writeln (NewIniFile,TempStr);
              UNTIL TempStr = GameTitle;
              readln (IniFile,TempStr);
              writeln (NewIniFile,TempStr);
              readln (IniFile,TempStr);
              writeln (NewIniFile,TempStr);
              readln (IniFile,TempStr);
              writeln (NewIniFile,GamePath + '\');
              REPEAT
                readln (IniFile,TempStr);
                writeln (NewIniFile,TempStr);
              UNTIL Eof(IniFile);
            END
          ELSE
            BEGIN
              mkdir (GamerPath + '\' + AddonDir);
              writeln (NewIniFile,GameTitle);
              writeln (NewIniFile,AddonDir);
              writeln (NewIniFile,'NONE');
              writeln (NewIniFile,GamePath + '\');
              REPEAT
                readln (IniFile,TempStr);
                writeln (NewIniFile,TempStr);
              UNTIL Eof(IniFile);
            END;
        close (IniFile);
        close (NewIniFile);
        SetFAttr (NewIniFile,Archive);
        erase (IniFile);
        rename (NewIniFile,GamerPath + '\GAMER.INI');
      END;

  findfirst (BootDrive + ':\WINDOWS',Directory,DirInfo);
  IF DosError = 0 THEN
      assign (IniFile,BootDrive + ':\WINDOWS\GAMER.INI')
    ELSE assign (IniFile,BootDrive + ':\GAMER.INI');
  rewrite (IniFile);
  writeln (IniFile,'// This file tells the GAMER installer where you last installed GAMER.');
  writeln (IniFile,'// If you delete this file, it will not be able to auto-detect GAMER.');
  writeln (IniFile,GamerPath);
  close (IniFile);

  TotalBytes := 0;
  FOR Count := 1 TO NumFiles DO
    BEGIN
      findfirst (Addon_Dir + '\' + FileList[Count],Archive,DirInfo);
      TotalBytes := TotalBytes + DirInfo.Size;
    END;
  PercentDone := 0;
  FOR Count := 1 TO NumFiles DO
    BEGIN
      TcTb (14,1);
      WrtS (24,3,'            ');
      WrtS (24,3,FileList[Count]);
{////////////////////////////////////////////////////////////////////////////}
{ ADDON DEPENDENT... CHANGES WITH EVERY ADD-ON }

      {Checks to see if the version of GAMER being installed is higher than
      what is already installed...if not, then it installs over it }

      IF ((FileList[Count] = 'GAMER.EXE') OR (FileList[Count] = 'README.TXT')) AND (GamerVersion <= New_Gamer_Version) THEN
          BEGIN
            CopyFile (FileList[Count],Addon_Dir + '\',GamerPath + '\',PercentDone,TotalBytes);
            TempStr := Addon_Dir + '\' + GamerPath + '\' + FileList[Count];
            SetFAttr (TempStr,Archive);
          END;
      IF ((FileList[Count] <> 'GAMER.EXE') AND (FileList[Count] <> 'README.TXT')) THEN
          BEGIN
            CopyFile (FileList[Count],Addon_Dir + '\',GamerPath + '\' + AddonDir + '\',PercentDone,TotalBytes);
            TempStr := Addon_Dir + '\' + GamerPath + '\' + FileList[Count];
            SetFAttr (TempStr,Archive);
          END ;
{////////////////////////////////////////////////////////////////////////////}

    END;
  TcTb (14,1);
  clrscr;
  WrtS (9,1,'Thank you very much for installing ' + Addon_Title);
  TcTb (15,1);
  WrtS (5,2,'To run the GAMER software simply type GAMER at the DOS prompt.');
  WrtS (2,3,'From there you will be able to activate and play ' + Addon_Title + '.');
  TcTb (11,1);
  WrtS (25,4,'Press <ENTER> to exit...');
  REPEAT
    TempChar := readkey;
  UNTIL TempChar IN [#13];
END;

{***************************************************************************}
PROCEDURE WhichVersion (GamePath : PathType; VAR GameVersion : STRING);

VAR
  Menu         : MenuType;
  Cursor       : Byte;
  ExitVals     : ExitCharSet;
  Choice       : Char;
  TempStr      : STRING;
  DirInfo      : SearchRec;
  DateStamp    : LongInt;
  CheckVersion : TEXT;

BEGIN
{////////////////////////////////////////////////////////////////////////////}
{ ADDON DEPENDENT... CHANGES WITH EVERY ADD-ON }

  {finds the version of the game for the addon being installed. Might not be
  needed for some addons that come out before new versions.}

  IF CheckFile ('\' + Game_ID_File,GamePath,Archive) THEN
      BEGIN
        findfirst (GamePath + '\DUKE3D.EXE',Archive,DirInfo);
        CASE (DirInfo.Size DIV 1000) OF
          1179 : GameVersion := '13';
          1240 : GameVersion := 'PP';
          ELSE GameVersion := '15';
        END;
      END
    ELSE
      BEGIN
        Error := 3;
        Quit := True;
        Exit;
      END;

  {will need to change this when I find out about patches, etc.}
{  IF CheckFile ('\' + Game_ID_File,GamePath,Archive) THEN
      BEGIN
        findfirst (GamePath + '\' + '*.cfg',AnyFile,DirInfo);
        IF DOSError = 0 THEN
            BEGIN
              assign (CheckVersion,GamePath + '\' + DirInfo.Name);
              reset (CheckVersion);
              REPEAT
                readln (CheckVersion,TempStr);
              UNTIL (TempStr[1] = 'S') OR (EoF(CheckVersion));
              close (CheckVersion);
              IF TempStr = 'SetupVersion = "1.3D"' THEN
                  GameVersion := '13'
                ELSE GameVersion := 'PP';
            END}

{////////////////////////////////////////////////////////////////////////////}

END;

{***************************************************************************}
PROCEDURE FindGame (GamerPath : PathType; VAR GamePath : PathType);

VAR
  IniFile  : TEXT;
  TempStr  : STRING;
  Menu     : MenuType;
  Cursor   : Byte;
  Choice   : Char;
  ExitVals : ExitCharSet;
  Found    : Boolean;
  DirInfo  : SearchRec;

BEGIN
  MainScreenSetup;
  Found := False;

{////////////////////////////////////////////////////////////////////////////}
{ ADDON DEPENDENT... CHANGES WITH EVERY ADD-ON }

  IF GamePath <> 'RETRY' THEN
      BEGIN
        findfirst (GamerPath + '\GAMER.INI',Archive,DirInfo);
        IF DosError = 0 THEN
            BEGIN
              assign (IniFile,GamerPath + '\GAMER.INI');
              reset (IniFile);

              {finds the game in the gamer.ini file if an addon is already
              installed}
              REPEAT
                readln (IniFile,TempStr);
              UNTIL EoF(IniFile) OR (TempStr = Game_Title);
              IF (TempStr = Game_Title) THEN
                  BEGIN
                    readln (IniFile,TempStr);
                    readln (IniFIle,TempStr);
                    readln (IniFIle,TempStr);
                    findfirst (TempStr + Game_ID_File,Archive,DirInfo);
                    IF DosError = 0 THEN
                        BEGIN
                          Found := True;
                          GamePath := TempStr;
                          delete (GamePath,length(GamePath),1);
                        END;
                  END;
              close (IniFile);
            END;
        IF NOT Found THEN
            BEGIN
              findfirst (BootDrive + ':\GAMES\' + Game_ID_Dir + '\' + Game_ID_File,Archive,DirInfo);
              IF DosError = 0 THEN
                BEGIN
                  Found := True;
                  GamePath := BootDrive + ':\GAMES\' + Game_ID_Dir;
                END;
              IF NOT Found THEN
                BEGIN
                  findfirst (BootDrive + ':\' + Game_ID_Dir + '\' + Game_ID_File,Archive,DirInfo);
                  IF DosError = 0 THEN
                      BEGIN
                        Found := True;
                        GamePath := BootDrive + ':\' + Game_ID_Dir;
                      END;
                END;
            END;
      END;
{////////////////////////////////////////////////////////////////////////////}

{////////////////////////////////////////////////////////////////////////////}
{ ADDON DEPENDENT... CHANGES WITH EVERY ADD-ON }
  IF NOT Found THEN
      BEGIN
        MakeWin (9,1,8,7,66,5,True,True);
        TcTb (14,1);
        WrtS (2,1,'Type the directory where ' + Game_Title + ' is located:');
        TcTb (15,1);
        WrtS (2,2,'  Example: ' + BootDrive + ':\' + Game_ID_Dir);
        TcTb (7,1);
        write (' (Please include the drive letter)');
        ReadPath (10,10,60,GamePath);
        IF GamePath = 'EXITED' THEN
            BEGIN
              Error := 1;
              Quit := True;
              Exit;
            END;
        findfirst (GamePath + '\' + Game_ID_File,Archive,DirInfo);
        IF DosError = 0 THEN Found := True
          ELSE
            BEGIN
              TcTb (14,1);
              window (10,8,75,8);
              WrtS (1,1,'Could not locate ' + Game_Title + ' there! Try again please:  ');
              REPEAT
                 Beep (1000,50);
                 ReadPath (10,10,60,GamePath);
                 IF GamePath = 'EXITED' THEN
                     BEGIN
                       Error := 1;
                       Quit := True;
                       Exit;
                     END;
                 findfirst (GamePath + '\' + Game_ID_File,Archive,DirInfo);
                 IF DosError = 0 THEN Found := True;
              UNTIL Found OR (GamePath = 'EXITED');
            END;
        IF GamePath = 'EXITED' THEN
            BEGIN
              Error := 1;
              Quit := True;
              Exit;
            END;
      END;
{////////////////////////////////////////////////////////////////////////////}

{////////////////////////////////////////////////////////////////////////////}
{ ADDON DEPENDENT... CHANGES WITH EVERY ADD-ON }
  IF Found THEN
      BEGIN
        findfirst (GamePath + '\*.cfg',AnyFile,DirInfo);
        assign (IniFIle,GamePath + '\' + DirInfo.Name);
        reset (IniFile);
        REPEAT
          readln (IniFile,TempStr);
        UNTIL (TempStr[1] = 'S') OR (EoF(IniFile));
        delete (TempStr,pos('=',TempStr),length(TempStr));
        IF TempStr <> 'SetupVersion ' THEN
          BEGIN
            Error := 3;
            Quit := True;
            Exit;
          END;
        close (IniFile);

      END;
  IF Found THEN
      BEGIN
        MakeWin (9,1,8,7,66,6,True,True);
        TcTb (15,1);
        WrtS (2,1,Game_Title + ' was located in the following directory:');
        TcTb (14,1);
        WrtS (2,2,GamePath);
        TcTb (11,1);
        WrtS (14,3,'Do you wish to accept this? ');
        TcTb (15,1);
        Menu[1] := ' YES ';
        Menu[2] := ' NO ';
        Cursor := 1;
        ExitVals := [#13,#27];
        WrtS (42,3,Menu[1]);
        WrtS (42,4,Menu[2]);
        ArraySelect (15,1,8 + 16,7,42,3,2,Cursor,Choice,Menu,ExitVals);
        IF Choice = #27 THEN
            BEGIN
              Error := 1;
              Quit := True;
              Exit;
            END
          ELSE
            IF Cursor = 2 THEN GamePath := 'RETRY';
      END;
{////////////////////////////////////////////////////////////////////////////}

END;

{***************************************************************************}
PROCEDURE GamerSoftwareExist (VAR GamerPath : PathType);

VAR
  DirInfo      : SearchRec;
  CheckFile    : TEXT;
  TempChar     : Char;

BEGIN
  TempChar := 'N';
  findfirst (BootDrive + ':\WINDOWS\GAMER.INI',Archive,DirInfo);
  IF DosError = 0 THEN TempChar := 'W';
  findfirst (BootDrive + ':\GAMER.INI',Archive,DirInfo);
  IF DosError = 0 THEN TempChar := 'D';
  IF TempChar IN ['W','D'] THEN
      BEGIN
        IF TempChar = 'W' THEN
          assign (CheckFile,BootDrive + ':\WINDOWS\GAMER.INI');
        IF TempChar = 'D' THEN
          assign (CheckFile,BootDrive + ':\GAMER.INI');
        reset (CheckFile);
        readln (CheckFile,GamerPath);
        readln (CheckFile,GamerPath);
        readln (CheckFile,GamerPath);
        close (CheckFIle);
        findfirst (GamerPath + '\GAMER.INI',Archive,DirInfo);
        IF DOSError = 0 THEN
            BEGIN
              GamerExist := True;
              MainScreenSetup;
              MakeWin (9,1,8,7,66,6,True,True);
              TcTb (15,1);
              WrtS (2,1,'Your current version of GAMER is in the following directory:');
              WrtS (2,3,'The ' + Addon_Title + ' add-on will be installed there.');
              TcTb (14,1);
              WrtS (2,2,GamerPath);
              TcTb (11,1);
              WrtS (38,4,'Press <ENTER> to continue');
              TcTb (15,1);
              REPEAT
                TempChar := readkey;
              UNTIL TempChar IN [#13,#27];
              IF TempChar = #27 THEN
                BEGIN
                  Error := 1;
                  Quit := True;
                  Exit;
                END;
            END
          ELSE GamerExist := False;
      END
    ELSE GamerExist := False;
END;

{***************************************************************************}
FUNCTION IsDir(Dir : STRING) : Boolean;

VAR
  FHandle : FILE;
  WAttr   : Word;

BEGIN
  WHILE Dir[length(Dir)] = '\' DO dec(Dir[0]);
  Dir := Dir + '\.';
  assign(FHandle,Dir);
  getfattr(FHandle,WAttr);
  IsDir := ((WAttr AND Directory) = Directory);
END;

{***************************************************************************}
PROCEDURE NewGamer (VAR GamerPath : PathType);

VAR
  TestDir  : STRING;
  Menu     : MenuType;
  Count,
  LastPos,
  Cursor   : Byte;
  Choice   : Char;
  ExitVals : ExitCharSet;
  DirInfo  : SearchRec;
  TempPath : PathType;
  Valid    : Boolean;

BEGIN
  MainScreenSetup;
  MakeWin (9,1,8,7,66,5,True,True);
  TcTb (14,1);
  WrtS (2,1,'Type the directory to install the GAMER software into:');
  TcTb (15,1);
  WrtS (2,2,'  Example: ' + BootDrive + ':\GAMER');
  TcTb (7,1);
  write (' (Please include the drive letter)');
  ReadPath (10,10,60,GamerPath);
  IF GamerPath = 'EXITED' THEN
      BEGIN
        Error := 1;
        Quit := True;
        Exit;
      END;
  Valid := False;
  WHILE NOT Valid DO
    BEGIN
      FOR Count := 1 TO length(GamerPath) DO
        IF GamerPath[Count] = '\' THEN
            LastPos := Count;
      TestDir := GamerPath;
      delete (TestDir,LastPos,length(TestDir));
      Valid := IsDir (TestDir);
      IF (NOT(GamerPath[1] IN ['A'..'Z'])) OR
         (NOT(GamerPath[2] = ':')) OR
         (NOT(GamerPath[3] = '\')) THEN Valid := False;
      IF NOT Valid THEN
          BEGIN
            TcTb (14,1);
            window (10,8,75,8);
            WrtS (1,1,'Could not create that directory! Try again please:     ');
            Beep (1000,50);
            ReadPath (10,10,60,GamerPath);
            IF GamerPath = 'EXITED' THEN
                BEGIN
                  Error := 1;
                  Quit := True;
                  Exit;
                END;
          END;
    END;
  MakeWin (9,1,8,7,66,6,True,True);
  TcTb (15,1);
  WrtS (2,1,'GAMER will be installed in the following directory:');
  TcTb (14,1);
  WrtS (2,2,GamerPath);
  TcTb (11,1);
  WrtS (14,3,'Do you wish to accept this? ');
  TcTb (15,1);
  Menu[1] := ' YES ';
  Menu[2] := ' NO ';
  Cursor := 1;
  ExitVals := [#13,#27];
  WrtS (42,3,Menu[1]);
  WrtS (42,4,Menu[2]);
  ArraySelect (15,1,8 + 16,7,42,3,2,Cursor,Choice,Menu,ExitVals);
  IF Choice = #27 THEN
      BEGIN
        Error := 1;
        Quit := True;
        Exit;
      END
    ELSE
      IF Cursor = 2 THEN GamerPath := 'RETRY';
END;

{***************************************************************************}
FUNCTION Confirm : Boolean;

VAR
  Choice   : Char;

BEGIN
  MainScreenSetup;
  MakeWin (9,1,12,5,56,5,True,True);

{////////////////////////////////////////////////////////////////////////////}
{ ADDON DEPENDENT... CHANGES WITH EVERY ADD-ON }

  TcTb (15,1);
  WrtS (2,1,'Press <ENTER> to complete installation of:');
  TcTb (14,1);
  WrtS (4,2,Addon_Title);
  TcTb (11,1);
  WrtS (31,3,'Or press <ESC> to abort');

{////////////////////////////////////////////////////////////////////////////}

  REPEAT
    Choice := readkey;
  UNTIL Choice IN [#13,#27];
  IF Choice = #13 THEN Confirm := True
    ELSE Confirm := False;
END;

{***************************************************************************}
PROCEDURE Initialize
  (VAR FileList     : FileArray;
   VAR GamePath,
       GamerPath : PathType;
   VAR Version      : STRING);

BEGIN

{////////////////////////////////////////////////////////////////////////////}
{ ADDON DEPENDENT... CHANGES WITH EVERY ADD-ON }
  FileList[1] := Addon_Short;
  FileList[2] := 'GAMER.EXE';
  FileList[3] := 'README.TXT';
  FileList[4] := 'DVINTRO.TXT';
{////////////////////////////////////////////////////////////////////////////}

  Error := 0;
  ErrorInfo := '';
  GamePath := '';
  GamerPath := '';
  Version := '';
  Quit := False;
  BootDrive := Startup_Drive;
END;

{***************************************************************************}
PROCEDURE ControlProcessing;

VAR
  FileList     : FileArray;
  GameVersion  : STRING;
  GamerPath,
  GamePath     : PathType;

BEGIN
  Initialize (FileList,GamePath,GamerPath,GameVersion);
  Quit := IntroScreen;
  IF Quit THEN
    BEGIN
      Error := 1;
      Exit;
    END;
  GamerSoftwareExist (GamerPath);
  IF NOT(GamerExist) THEN
      REPEAT
        NewGamer (GamerPath);
      UNTIL Quit OR (GamerPath <> 'RETRY');
  IF Quit THEN Exit;
  REPEAT
    FindGame (GamerPath,GamePath);
  UNTIL Quit OR (GamePath <> 'RETRY');
  IF Quit THEN Exit;
  WhichVersion (GamePath,GameVersion);
{  IF GameVersion = 'ABORT!' THEN
    BEGIN
      Quit := True;
      Error := 1;
      Exit;
    END;}
{  IF GameVersion <> '"1.02"' THEN
    BEGIN
      Error := 4;
      ErrorInfo := GameVersion;
      Exit;
    END;}
  IF Quit THEN Exit;
  IF Confirm THEN InstallAddon (FileList,GameVersion,GamePath,GamerPath)
    ELSE
      BEGIN
        Quit := True;
        Error := 1;
        Exit;
      END;
{  chdir (GamerPath);}
END;

{***************************************************************************}
PROCEDURE OutputError;

BEGIN

  writeln ('Installation of ', Addon_Title, ' aborted!');
  write ('Reason: ');
  CASE Error OF
    1 : writeln ('User exited the program early');
    2 : writeln ('Disk full - free up ', (DiskSpace * 10):0:0, ' megs and try again');
    3 : writeln ('Please configure ', Game_Title, ' before installing ', Addon_Title);
{    4 : BEGIN
          IF ErrorInfo = '"1.0"' THEN
              BEGIN
                writeln;
                writeln ('  Cryptic Passage needs Blood version 1.02 to run properly.');
                writeln ('  You''re current version of Blood is 1.0');
                writeln ('  Install will now run the Blood version 1.0 to 1.02 patch.');
                writeln;
                writeln ('  When it asks where "current system resides" enter your Blood directory.');
                writeln;
                writeln ('  Please note: This patch will requires 30 megs of hard drive space');
                writeln ('  Please make sure you have enough hard drive space available.');
                writeln;
                writeln ('  Press <ENTER> to continue...');
                REPEAT
                  ReadChar := upcase(Readkey);
                UNTIL ReadChar = #13;
                SwapVectors;
                exec ('PATCHES\R0002.EXE','');
                SwapVectors;
              END
          ELSE
            IF ErrorInfo = '"1.01"' THEN
              BEGIN
                writeln;
                writeln ('  Cryptic Passage needs Blood version 1.02 to run properly.');
                writeln ('  You''re current version of Blood is 1.01');
                writeln;
                writeln ('  When it asks where "current system resides" enter your Blood directory.');
                writeln;
                writeln ('  Please note: This patch will requires 30 megs of hard drive space');
                writeln ('  Please make sure you have enough hard drive space available.');
                writeln;
                writeln ('  Press <ENTER> to continue...');
                REPEAT
                  ReadChar := upcase(Readkey);
                UNTIL ReadChar = #13;
                SwapVectors;
                exec ('PATCHES\R0102.EXE','');
                SwapVectors;
              END;
        END;}
  END;

  writeln;

END;

{***************************************************************************}

BEGIN
  REPEAT
    OrigMode := LastMode;
    TextMode (3);
    HighIntensity;
    CursorOff;
    ControlProcessing;
    CursorOn;
    TextMode (OrigMode);
  IF (Error > 0) THEN
      OutputError
    ELSE
      BEGIN
        writeln ('When you want to activate or deactivate a Sunstorm add-on, go into your');
        writeln ('GAMER directory and type GAMER.EXE');
        writeln ('Once DUKE CARIBBEAN has been activated, you can go into your DUKE 3D');
        writeln ('directory at anytime and type CARIB.EXE to play DUKE CARIBBEAN.');
        writeln ('Thank you for your support.');
        writeln;
      END;
  UNTIL (Error <> 4);
END.