{***************************************************************************
PROCEDURE WriteINI;

VAR
  INIFile   : Text;
  BloodPath : PathStr;
  Count     : Integer;

BEGIN
  BloodPath := fsearch('CRYPTIC.EXE',getenv('PATH'));

  BloodPath := fexpand(BloodPath);

  Count := length (BloodPath);

  REPEAT
    IF BloodPath[Count] <> '\' THEN delete (BloodPath,Count,1);
    dec(Count);
  UNTIL BloodPath[Count] = '\';

  Count := 4;
  REPEAT
    IF (ord(BloodPath[Count]) IN [65..90]) THEN
      BloodPath[Count] := chr(ord(BloodPath[Count]) + 32);
    inc(count);
  UNTIL Count = length(BloodPath);

  assign (INIFile,'CRYPTIC.INI');
  rewrite (INIFile);
  writeln (INIFile,';=====================================================================');
  writeln (INIFile,'; Blood Initialization File');
  writeln (INIFile,';');
  writeln (INIFile,'; Copyright (c)1996-1997 Monolith Productions Inc.');
  writeln (INIFile,'; All Rights Reserved Worldwide');
  writeln (INIFile,';');
  writeln (INIFile,';---------------------------------------------------------------------');
  writeln (INIFile,'; Syntax:');
  writeln (INIFile,';');
  writeln (INIFile,'; [install]');
  writeln (INIFile,'; SourceDir= drive and path');
  writeln (INIFile,';');
  writeln (INIFile,'; [Episode#]');
  writeln (INIFile,';	Title		= episodeTitle');
  writeln (INIFile,';       BloodBathOnly   = flag  0 or not present means multi and single');
  writeln (INIFile,';                         any other number means multi play only');
  writeln (INIFile,';       CutSceneALevel  = Level number to play Cut Scene A.  Defaults to');
  writeln (INIFile,';			  first level of episode.');
  writeln (INIFile,';');
  writeln (INIFile,';	These are set to the file and path of the videos on the CD by');
  writeln (INIFile,';	  the Blood install program.');
  writeln (INIFile,';	CutSceneA	= File and Path of Smacker video to play at entry');
  writeln (INIFile,';			  to specified (in CutSceneALevel) level.');
  writeln (INIFile,';	CutWavA		= File and Path of WAV audio to play (during video)');
  writeln (INIFile,';	CutSceneB	= File and Path of Smacker video to play at end of');
  writeln (INIFile,';			  episode');
  writeln (INIFile,';	CutWavB		= File and Path of WAV audio to play (during video)');
  writeln (INIFile,';');
  writeln (INIFile,';	Map#		= mapFile');
  writeln (INIFile,';');
  writeln (INIFile,'; [mapFile]');
  writeln (INIFile,';	Title		= title');
  writeln (INIFile,';	Author		= author');
  writeln (INIFile,';	Song		= songFile');
  writeln (INIFile,';       Track           = redbookTrack#');
  writeln (INIFile,';	EndingA		= map#');
  writeln (INIFile,';	EndingB		= map#');
  writeln (INIFile,';	Fog		= 0 | 1');
  writeln (INIFile,';		0 == Fog disabled');
  writeln (INIFile,';		1 == Fog enabled');
  writeln (INIFile,';	Message1	= message');
  writeln (INIFile,';	..		..');
  writeln (INIFile,';	Message32	= message');
  writeln (INIFile,';');
  writeln (INIFile,';=====================================================================');
  writeln (INIFile,'[Install]');
  writeln (INIFile,'; source path will be set by the installation process');
  writeln (INIFile,'SourceDir=', BloodPath);
  writeln (INIFile,'');
  writeln (INIFile,'[Episode1]');
  writeln (INIFile,'; location of movies was set at install');
  writeln (INIFile,'CutSceneB=', BloodPath, 'cryptic.smk');
  writeln (INIFile,'CutWavB=', BloodPath, 'cryptic.wav');
  writeln (INIFile,'Title   = Cryptic Passage');
  writeln (INIFile,'Map1    = cp01');
  writeln (INIFile,'Map2    = cp02');
  writeln (INIFile,'Map3    = cp03');
  writeln (INIFile,'Map4    = cp04');
  writeln (INIFile,'Map5    = cp05');
  writeln (INIFile,'Map6    = cp06');
  writeln (INIFile,'Map7    = cp07');
  writeln (INIFile,'Map8    = cp08');
  writeln (INIFile,'Map9    = cp09');
  writeln (INIFile,'Map10   = cpsl');
  writeln (INIFile,'');
  writeln (INIFile,'[Episode2]');
  writeln (INIFile,'Title  = Cryptic BloodBath');
  writeln (INIFile,'BloodBathOnly=1');
  writeln (INIFile,'Map1   = cpbb01');
  writeln (INIFile,'Map2   = cpbb02');
  writeln (INIFile,'Map3   = cpbb03');
  writeln (INIFile,'Map4   = cpbb04');
  writeln (INIFile,'');
  writeln (INIFile,';Episode 1');
  writeln (INIFile,';Cryptic Passage');
  writeln (INIFile,'');
  writeln (INIFile,'[cp01]');
  writeln (INIFile,'Title           = Boat Docks');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood8');
  writeln (INIFile,'Track           = 6');
  writeln (INIFile,'EndingA         = 2');
  writeln (INIFile,'EndingB         = 2');
  writeln (INIFile,'');
  writeln (INIFile,'[cp02]');
  writeln (INIFile,'Title           = Old Opera House');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song            = PESTIS');
  writeln (INIFile,'Track           = 2');
  writeln (INIFile,'EndingA         = 3');
  writeln (INIFile,'EndingB         = 3');
  writeln (INIFile,'');
  writeln (INIFile,'[cp03]');
  writeln (INIFile,'Title           = Gothic Library');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood10');
  writeln (INIFile,'Track           = 8');
  writeln (INIFile,'EndingA         = 4');
  writeln (INIFile,'EndingB         = 4');
  writeln (INIFile,'');
  writeln (INIFile,'[cp04]');
  writeln (INIFile,'Title           = Lost Monastery');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood9');
  writeln (INIFile,'Track           = 7');
  writeln (INIFile,'EndingA         = 5');
  writeln (INIFile,'EndingB         = 5');
  writeln (INIFile,'');
  writeln (INIFile,'[cp05]');
  writeln (INIFile,'Title           = Steamboat');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood1');
  writeln (INIFile,'Track           = 9');
  writeln (INIFile,'EndingA         = 6');
  writeln (INIFile,'EndingB         = 6');
  writeln (INIFile,'');
  writeln (INIFile,'[cp06]');
  writeln (INIFile,'Title           = Graveyard');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood3');
  writeln (INIFile,'Track           = 7');
  writeln (INIFile,'EndingA         = 7');
  writeln (INIFile,'EndingB         = 10');
  writeln (INIFile,'');
  writeln (INIFile,'[cp07]');
  writeln (INIFile,'Title           = Mountain Pass');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = unholy');
  writeln (INIFile,'Track           = 3');
  writeln (INIFile,'EndingA         = 8');
  writeln (INIFile,'EndingB         = 8');
  writeln (INIFile,'');
  writeln (INIFile,'[cp08]');
  writeln (INIFile,'Title           = Abysmal Mine');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood7');
  writeln (INIFile,'Track           = 5');
  writeln (INIFile,'EndingA         = 9');
  writeln (INIFile,'EndingB         = 9');
  writeln (INIFile,'');
  writeln (INIFile,'[cp09]');
  writeln (INIFile,'Title           = The Castle');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood7');
  writeln (INIFile,'Track           = 5');
  writeln (INIFile,'');
  writeln (INIFile,'[cpsl]');
  writeln (INIFile,'Title           = Boggy Creek');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood7');
  writeln (INIFile,'Track           = 5');
  writeln (INIFile,'EndingA         = 7');
  writeln (INIFile,'EndingB         = 7');
  writeln (INIFile,'');
  writeln (INIFile,';Episode 2');
  writeln (INIFile,';Cryptic BloodBath');
  writeln (INIFile,'');
  writeln (INIFile,'[cpbb01]');
  writeln (INIFile,'Title           = Crypt of Despair');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = unholy');
  writeln (INIFile,'Track           = 3');
  writeln (INIFile,'');
  writeln (INIFile,'[cpbb02]');
  writeln (INIFile,'Title           = Pits of Blood');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood2');
  writeln (INIFile,'Track           = 5');
  writeln (INIFile,'');
  writeln (INIFile,'[cpbb03]');
  writeln (INIFile,'Title           = Unholy Cathedral');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood7');
  writeln (INIFile,'Track           = 6');
  writeln (INIFile,'');
  writeln (INIFile,'[cpbb04]');
  writeln (INIFile,'Title           = Deadly Inspirations');
  writeln (INIFile,'Author          = Sunstorm Interactive');
  writeln (INIFile,'Song	    = cblood7');
  writeln (INIFile,'Track           = 6');
  close (INIFile);

END;

