{$M $9999,0,655360}
PROGRAM UndoSSI;

USES
  Crt,
  List2Data,
  List2ADT;

TYPE
  BufferType = ARRAY [1..64000] OF Char;

VAR
  SSIScp      : Text;
  SSIFile,
  InsertFile  : File;
  Counter,
  FileParse,
  Version,
  TOCSize,
  LeftToRead  : LongInt;
  SSITitle    : STRING[32];
  SSIFileName : STRING[12];
  SSILauncher : STRING[12];
  LongDescrpt : ARRAY [1..3] OF STRING[70];
  Count       : 1..400;
  NumRead,
  NumWritten  : Word;
  Buffer      : ^BufferType;
  TOCItem     : ListElementType;
  TOC         : ListType;

BEGIN
  clrscr;
  IF ParamCount = 0 THEN
      writeln ('You need to specify an SSI file wierdo!');
  IF ParamCount >= 1 THEN
    BEGIN
      SSIFileName := ParamStr(1);
      assign (SSIFile,ParamStr(1));
      reset (SSIFile,1);
      blockread (SSIFile,Version,sizeof(Version),NumRead);
      blockread (SSIFile,TOCSize,sizeof(TOCSize),NumRead);
      blockread (SSIFile,SSITitle,sizeof(SSITitle),NumRead);
      IF Version > 1 THEN
          blockread (SSIFile,SSILauncher,sizeof(SSILauncher),NumRead);
      blockread (SSIFile,LongDescrpt,sizeof(LongDescrpt),NumRead);
      CreateList (TOC);
      FOR Count := 1 TO TOCSize DO
        BEGIN
          blockread (SSIFile,TOCItem,sizeof(TOCItem),NumRead);
          InsertElement (TOC,TOCItem);
        END;
      writeln ('Unpacking SSI File: ', ParamStr(1));
      writeln ('SSI Title: ', SSITitle);
      writeln ('SSI File Type Version: ', Version);
      writeln ('SSI File Launcher: ',SSILauncher);
      writeln ('SSI File Description:');
      FOR Count := 1 TO 3 DO  writeln ('  ',LongDescrpt[Count]);
      writeln ('Number of Files to Extract: ', TOCSize);
      ResetList (TOC);
      FOR Count := 1 TO TOCSize DO
        BEGIN
          GetNextItem (TOC,TOCItem);
          writeln ('Extracting File: ', TOCItem.FileName);
          assign (InsertFile,TOCItem.FileName);
          rewrite (InsertFile,1);
          new(Buffer);
          LeftToRead := TOCItem.FileSize;
          WHILE LeftToRead > 0 DO
            BEGIN
              IF LeftToRead > 64000 THEN
                  BEGIN
                    blockread (SSIFile,Buffer^,sizeof(Buffer^),NumRead);
                    blockwrite (InsertFile,Buffer^,NumRead,NumWritten);
                    LeftToRead := LeftToRead - 64000;
                  END
                ELSE
                  BEGIN
                    blockread (SSIFile,Buffer^,LeftToRead,NumRead);
                    blockwrite (InsertFile,Buffer^,NumRead,NumWritten);
                    LeftToRead := 0;
                  END;
            END;
          dispose(Buffer);
          close (InsertFile);
        END;
      close (SSIFile);
    END;

    assign (SSIScp, 'UNDOSSI.SCP');
    rewrite (SSIScp);
    writeln (SSIScp,SSIFileName);
    writeln (SSIScp,Version);
    writeln (SSIScp,TOCSize);
    writeln (SSIScp,SSITitle);
    IF Version > 1 THEN
        writeln (SSIScp,SSILauncher);
    writeln (SSIScp,LongDescrpt[1]);
    writeln (SSIScp,LongDescrpt[2]);
    writeln (SSIScp,LongDescrpt[3]);
    ResetList (TOC);
    FOR Count := 1 TO TOCSize DO
      BEGIN
        GetNextItem (TOC,TOCItem);
        writeln (SSIScp,TOCItem.FileName);
        writeln (SSIScp,TOCItem.GameDir);
        writeln (SSIScp,TOCItem.SubDir);
        writeln (SSIScp,TOCItem.GameVer);
        writeln (SSIScp,TOCItem.String2);
        writeln (SSIScp,TOCItem.Integer1);
        writeln (SSIScp,TOCItem.Integer2);
      END;
    close (SSIScp);
    writeln ('UNDOSSI Script file Generated.');

END.